// basic object
var version = java.lang.System.getProperty("java.version");
if (version.startsWith("1.8.0")) {
    load("nashorn:mozilla_compat.js");
}

importPackage( java.util ) ;
importPackage( com.infoteria.asteria.warp.task.ui ) ;

var _tool = new Object() ;
var util = new Object() ;

_tool.Config = new Object() ;


_tool.TYPE_APPEND = 1 ;
_tool.TYPE_RECORD = 2 ;
_tool.TYPE_VARIABLE = 4 ;
_tool.TYPE_NONE = 8 ;

_tool.CHILDREN_FILE = 1 ;
_tool.CHILDREN_FILEINFO = 2 ;
_tool.CHILDREN_MAILADDRESS = 3 ;

_tool.FIELD_TYPES = [
		{ value : 'string' , dispkey : 'label_string' , type : _tool.TYPE_RECORD , isarray : false , imagekey : "navi_n_text" } ,
		{ value : 'string_n' , dispkey : 'label_string_n' , type : _tool.TYPE_APPEND , isarray : false , imagekey : "navi_n_text" , append : "fixedlength" } ,
		{ value : 'boolean' , dispkey : 'label_boolean' , type : _tool.TYPE_RECORD , isarray : false , imagekey : "navi_n_bool" } ,
		{ value : 'integer' , dispkey : 'label_integer' , type : _tool.TYPE_RECORD , isarray : false , imagekey : "navi_n_number" } ,
		{ value : 'double' , dispkey : 'label_double' , type : _tool.TYPE_RECORD , isarray : false , imagekey : "navi_n_number" } ,
		{ value : 'decimal' , dispkey : 'label_decimal' , type : _tool.TYPE_RECORD , isarray : false , imagekey : "navi_n_number" } ,
		{ value : 'packeddecimal' , dispkey : 'label_packeddecimal' , type : _tool.TYPE_APPEND , isarray : false , imagekey : "navi_n_number" , append : "fixedlength" } ,
		{ value : 'zoneddecimal' , dispkey : 'label_zoneddecimal' , type : _tool.TYPE_APPEND , isarray : false , imagekey : "navi_n_number" , append : "fixedlength" } ,
		{ value : 'datetime' , dispkey : 'label_datetime' , type : _tool.TYPE_RECORD , isarray : false , imagekey : "navi_n_date" } ,
		{ value : 'binary' , dispkey : 'label_binary' , type : _tool.TYPE_RECORD , isarray : false , imagekey : "navi_n_bin" } ,
		{ value : 'FileData' , dispkey : 'label_filedata' , type : _tool.TYPE_VARIABLE , isarray : false , children : _tool.CHILDREN_FILE , imagekey : "navi_n_file" } ,
		{ value : 'MailAddress' , dispkey : 'label_mailadrs' , type : _tool.TYPE_VARIABLE , isarray : false , children : _tool.CHILDREN_MAILADDRESS , imagekey : "navi_n_mail" } ,
		{ value : 'xml' , dispkey : 'label_xml' , type : _tool.TYPE_RECORD , isarry : false , imagekey : "navi_n_xml" } ,
		{ value : 'string[]' , dispkey : 'label_ary_string' , type : _tool.TYPE_VARIABLE , isarray : true , imagekey : "navi_n_text" } ,
		{ value : 'boolean[]' , dispkey : 'label_ary_boolean' , type : _tool.TYPE_VARIABLE , isarray : true , imagekey : "navi_n_bool"  } ,
		{ value : 'integer[]' , dispkey : 'label_ary_integer' , type : _tool.TYPE_VARIABLE , isarray : true , imagekey : "navi_n_number" } ,
		{ value : 'double[]' , dispkey : 'label_ary_double' , type : _tool.TYPE_VARIABLE , isarray : true , imagekey : "navi_n_number" } ,
		{ value : 'decimal[]' , dispkey : 'label_ary_decimal' , type : _tool.TYPE_VARIABLE , isarray : true , imagekey : "navi_n_number" } ,
		{ value : 'datetime[]' , dispkey : 'label_ary_datetime' , type : _tool.TYPE_VARIABLE , isarray : true , imagekey : "navi_n_date" } ,
		{ value : 'binary[]' , dispkey : 'label_ary_binary' , type : _tool.TYPE_NONE , isarray : true , imagekey : "navi_n_bin" } ,
		{ value : 'FileData[]' , dispkey : 'label_ary_filedata' , type : _tool.TYPE_NONE , isarray : true , children : _tool.CHILDREN_FILE , imagekey : "navi_n_file" } ,
		{ value : 'MailAddress[]' , dispkey : 'label_ary_mailadrs' , type : _tool.TYPE_NONE , isarray : true , children : _tool.CHILDREN_MAILADDRESS , imagekey : "navi_n_mail" }
	] ;

_tool.FIELD_CHILDREN = [
	{ value : _tool.CHILDREN_FILE , dispown : false , list : [
			{ name : "FilePath" , type : "string" } ,
			{ name : "FileName" , type : "string" } ,
			{ name : "Data" , type : "binary" } ,
			{ name : "Size" , type : "integer" } ,
			{ name : "LastModified" , type : "datetime" }
		] } ,
	{ value : _tool.CHILDREN_FILEINFO , dispown : false , list : [
			{ name : "FilePath" , type : "string" } ,
			{ name : "FileName" , type : "string" } ,
			{ name : "Size" , type : "integer" } ,
			{ name : "LastModified" , type : "datetime" }
		] } ,
	{ value : _tool.CHILDREN_MAILADDRESS , dispown : false , list : [
			{ name : "Name" , type : "string" } ,
			{ name : "Address" , type : "string" }
		] }
	] ;

_tool.convertFieldTypeToString = function( typ ) {
	for ( var cnt = 0 ; cnt < _tool.FIELD_TYPES.length ; cnt++ ) {
		if ( typ == _tool.FIELD_TYPES[cnt]['value'] ) {
			return util.LiteralBundle.getLiteral( _tool.FIELD_TYPES[cnt]['dispkey'] ) ;
		}
	}
	return "None" ;
}

_tool.E_TASK = "Pipeline" ;
_tool.E_PROP = "Property" ;
_tool.E_STAGE = "Stage" ;
_tool.E_ACTION = "Action" ;
_tool.E_CONFIG = "Config" ;
_tool.E_INTERFACE = "Interface" ;
_tool.E_FIELDS = "Fields" ;
_tool.E_FIELD  = "Field" ;
_tool.E_VARIABLES = "Variables" ;
_tool.E_VARIABLE = "Variable" ;

_tool.E_INPUT = "Input" ;
_tool.E_OUTPUT = "Output" ;
_tool.E_MAP = "Mapping" ;
_tool.E_ATTRIBUTE = "Attribute" ;

_tool.A_ID = "id" ;
_tool.A_NAME = "name" ;
_tool.A_VALUE = "value" ;
_tool.A_TYPE = "type" ;
_tool.A_ORDER = "order" ;
_tool.A_RUNMODE = "runmode" ;
_tool.A_MACRO = "macrotype" ;
_tool.A_EDITABLE = "editable" ;
_tool.A_DISPKEY = "dispkey" ;
_tool.A_ENHANCED = "enhanced" ;
_tool.A_DEFAULT = "default" ;
_tool.A_WEDGET = "wedget" ;
_tool.A_WIDTH = "width" ;
_tool.A_RDBBUTTON = "rdbbutton" ;

_tool.A_VALUE_USERDATA = "UserData" ;
_tool.A_VALUE_REQUESTPARAM = "RequestParam" ;

_tool.CONFIG_CONNECTION  = "connection" ;
_tool.CONFIG_NORMAL	  = "normal" ;
_tool.CONFIG_ERROR	   = "error" ;
_tool.CONFIG_VALIDATAION = "validataion" ;
_tool.CONFIG_SETTING	 = "setting" ;
_tool.CONFIG_SCHEDULE	= "schedule" ;
_tool.CONFIG__INFO	   = "_info" ;
_tool.CONFIG_FORMAT	  = "format" ;
_tool.CONFIG_FIELD	   = "field" ;


_tool.INTERFACE_ADD_FIELD = 1 ;
_tool.INTERFACE_CHANGE_FIELD = 2 ;
_tool.INTERFACE_REMOVE_FIELD = 3 ;

_tool.INTERFACE_EDIT_INIT = 0 ;
_tool.INTERFACE_EDIT_PRE_EASY = 1 ;
_tool.INTERFACE_EDIT_PRE_DETAIL = 2 ;
_tool.INTERFACE_EDIT_VARIABLE= 3 ;

_tool.INTERFACE_RECORD = "record" ;
_tool.INTERFACE_FIXEDLENGTH = "fixedlength" ;

_tool.VALIDATE_NONE = 0 ;
_tool.VALIDATE_NUMBER = 10 ;
_tool.VALIDATE_ALPHA = 20 ;
_tool.VALIDATE_MAIL = 30 ;
_tool.VALIDATE_DATE = 40 ;
_tool.VALIDATE_REQUIRED = 50 ;


_tool.RDB_TYPE_ALL = 0 ;
_tool.RDB_TYPE_ORACLE = 10 ;
_tool.RDB_TYPE_DB2 = 20 ;
_tool.RDB_TYPE_SQLSERVER = 30 ;
_tool.RDB_TYPE_MYSQL = 40 ;
_tool.RDB_TYPE_POSTGRES = 50 ;
_tool.RDB_TYPE_ISERIES = 60 ;
_tool.RDB_TYPE_INTERNALDB = 70 ;
_tool.RDB_TYPE_ODBC = 80 ;

_tool.ActionPackHelper = function() {} ;

_tool.ActionPackHelper.sensorData;
_tool.ActionPackHelper.filterData;
_tool.ActionPackHelper.jointData;
eval( "_tool.ActionPackHelper.sensorData = " + SensorData.toString() + ";" ) ;
eval( "_tool.ActionPackHelper.filterData = " + FilterData.toString() + ";" ) ;
eval( "_tool.ActionPackHelper.jointData = " + JointData.toString() + ";" ) ;

_tool.ActionPackHelper.ACTION_GENERAL  = 0 ;
_tool.ActionPackHelper.ACTION_PRESTAGE  = 1 ;
_tool.ActionPackHelper.ACTION_MAINSTAGE = 2 ;
_tool.ActionPackHelper.ACTION_POSTSTAGE = 3 ;

_tool.ActionPackHelper.ACTION_GENERAL_CONFIG = 10 ;
_tool.ActionPackHelper.ACTION_MAINSTAGE_CONFIG = 20 ;

_tool.ActionPackHelper.KEY_LITERAL = "key" ;
_tool.ActionPackHelper.KEY_ACTION_LITERAL = "key" ;
_tool.ActionPackHelper.KEY_ICON    = "group" ;
_tool.ActionPackHelper.KEY_LIB     = "name" ;

_tool.ActionPackHelper.getActionsData =function( stg ) {
    if ( stg == _tool.ActionPackHelper.ACTION_PRESTAGE ) {
        return _tool.ActionPackHelper.sensorData ;
    } else if ( stg == _tool.ActionPackHelper.ACTION_MAINSTAGE ) {
        return _tool.ActionPackHelper.filterData ;
    } else if ( stg == _tool.ActionPackHelper.ACTION_POSTSTAGE ) {
        return _tool.ActionPackHelper.jointData ;
    }
	return null ;
};

_tool.ActionPackHelper.getAction = function( lib , stg , getGroup ) {
    var actions = _tool.ActionPackHelper.getActionsData( stg ) ;
	if ( actions ) {
		actions = actions["Actions"] ;
		var action ;
        if ( actions[ _tool.ActionPackHelper.KEY_LITERAL ] ) {
            action = actions[ 'Action' ] ;
            if ( action[ _tool.ActionPackHelper.KEY_ACTION_LITERAL ] ) {
                if ( lib == action[ _tool.ActionPackHelper.KEY_LIB ] ) {
                    return getGroup ? actions : action ;
                }
            } else {
                for ( var kk = 0 ; action.length ; kk++ ) {
                    if ( lib == action[ kk ][ _tool.ActionPackHelper.KEY_LIB ] ) {
                        return getGroup ? actions : action[ kk ] ;
                    }
                }
            }
        } else {
            for ( var cnt = 0 ; cnt < actions.length ; cnt++ ) {
                action = actions[cnt][ 'Action' ] ;
                if ( action[ _tool.ActionPackHelper.KEY_ACTION_LITERAL ] ) {
                    if ( lib == action[ _tool.ActionPackHelper.KEY_LIB ] ) {
                        return getGroup ? actions[cnt] : action ;
                    }
                } else {
                    for ( var kk = 0 ; kk < action.length ; kk++ ) {
                        if ( lib == action[ kk ][ _tool.ActionPackHelper.KEY_LIB ] ) {
                            return getGroup ? actions[cnt] : action[ kk ] ;
                        }
                    }
                }
            }
        }
	}
	return null ;
};
_tool.ActionPackHelper.getActionName = function( stg , lib ) {
    var action = _tool.ActionPackHelper.getAction( lib , stg , false ) ;
    if ( action ) {
        if ( action[ "dispname" ] ) {
            return action[ "dispname" ] ;
        }
        return util.LiteralBundle.getLiteral( action[ "key" ] ) ;
    }
    return "undefine" ;
};

_tool.ActionPackHelper.getActionGroup = function( stg , lib ) {
    return _tool.ActionPackHelper.getAction( lib , stg , true ) ;
};

_tool.ActionPackHelper.getProprtyValue = function() {return "" ;} ;
_tool.ActionPackHelper.getBase64ProprtyValue = function() {return "" ;} ;
_tool.ActionPackHelper.setProprtyValue = function() {} ;

_tool.getProperty = function( targ, k ) {
	var p = targ[ _tool.E_PROP ] ;
	if ( p == null ) {
		return null ;
	} else if ( p[ _tool.A_NAME ] ) {
		if (p[ _tool.A_NAME ] == k) {
			return p ;
		}
	} else {
		for ( var kk = 0 ; kk < p.length ; kk++ ) {
			if ( p[ kk ][ _tool.A_NAME ] == k ) {
				return p[ kk ] ;
			}
		}
	}
	return null ;
}

_tool.decodepattern = new RegExp( "(<Pipeline_Field>)([^>]+)(</Pipeline_Field>)" , "g" ) ;
_tool.encodepattern = new RegExp( "(\\$<)([^>]+)(>)" , "g" ) ;
_tool.decodeMacro = function( txt ) {
	return txt.replace( _tool.decodepattern , "\$<$2>" ) ;
};
_tool.encodeMacro = function( txt ) {
	return txt.replace( _tool.encodepattern , "<Pipeline_Field>$2</Pipeline_Field>" ) ;
};

_tool.getFieldType = function( typ ) {
	var typs = _tool.FIELD_TYPES ;
	for ( var cnt = 0 ; cnt < typs.length ; cnt++ ) {
		if ( typ == typs[cnt].value ) {
			return typs[cnt] ;
		}
	}
	return null ;
}


var VConst = {
  INTERNAL_VALUE : "_value",
  INTERNAL_SET : "set",
  INTERNAL_GET : "get",
  TYPEOF_NUMBER : "number",
  TYPEOF_STRING : "string",
  TYPEOF_BOOLEAN : "boolean",
  TYPEOF_FUNCTION : "function",
  TYPEOF_OBJECT : "object"
} ;

function ExtendObject(dest,src) {
	for (var property in src) {
		dest[property] = src[property];
	}
	return dest;
}

function toFirstUp( str ) {
  return str.charAt(0).toUpperCase() + str.substring(1);
};

Function.prototype.extend = function(vSuper, vClassName) {
	var f = new Function ;
	f.prototype = vSuper.prototype ;
	ExtendObject( f.prototype , this ) ;
	this.prototype = new f ;
	this.superclass = vSuper;
	this.prototype.classname = this.classname = vClassName;
	this.prototype.constructor = this;
	return this.prototype ;
};

Function.prototype.addPropertyField = function(p) {
	var pp = this.prototype ;
	p.method = toFirstUp( p.name ) ;
	if ( ! p.defaultValue ) {
		p.defaultValue = null ;
	}
	var valueKey = VConst.INTERNAL_VALUE + p.method;
	pp[valueKey] = p.defaultValue;
	pp[VConst.INTERNAL_GET + p.method] = function() {
		return this[valueKey];
	};
    pp[VConst.INTERNAL_SET + p.method] = function(newValue) {
		var oldValue = this[valueKey];
		if (newValue === oldValue) { return newValue; };
		this[valueKey] = newValue;
		return newValue;
    };
};

// object
function VObject() {};

VObject.prototype.toString = function() {
	if ( this.classname )  return "[" + this.classname + "]" ;
	return "[object Object]" ;
};

VObject.prototype._disposed = false ;
VObject.prototype.getDisposed = function() {return this._disposed;};
VObject.prototype.isDisposed = function() {return this._disposed;};
VObject.prototype.dispose = function() {this._disposed = true ;}

VObject.prototype.set = function(propVal) {
	for (var prop in propVal) {
		this[prop](propVal[prop]);
    };
	return this;
};
VObject.prototype.get = function( propNm ) {
	switch( typeof propNm ) {
	case "string":
	return this[propNm] ;
	case "object":
	var len = propNm.length;
	for ( var v = 0 ; v < len ; v++ ) {
		propNm[v] = this[propNm[v]] ;
	}
	return propNm ;
	}
};

VObject.prototype.setUserData = function( vKey , vVal ) {
	if (!this._userData) {
		this._userData = {};
	};
	this._userData[vKey] = vVal;
};

VObject.prototype.getUserData = function( vKey ) {
	if (!this._userData) {
		return null;
	};
	return this._userData[vKey];
};

// target
function Target() {
	VObject.call( this ) ;
	this._parent = null ;
}
Target.extend(VObject ,"Target") ;

Target.prototype.addEventListener = function() {};
Target.prototype.removeEventListener = function() {};
Target.prototype.hasEventListener = function() {};
Target.prototype.createDispatchEvent = function() {};
Target.prototype.createDispatchDataEvent = function() {} ;
Target.prototype.dispatchEvent = function() {} ;
Target.prototype.getParent = function() { return this._parent ;}
Target.prototype.setParent = function(p) {this._parent = p ;}

// EOF// basic manager

// stagemanager
_tool.StageManager = function( ) { this._data = null; } ;

_tool.StageManager.prototype.setData = function( dat ) {
	this._data = dat ;
}

_tool.StageManager.prototype.getAction = function( odr ) {
	if ( this._data ) {
		var action = this._data[ _tool.E_ACTION ] ;
		if ( action == null ) {
			return null ;
		} else if ( action[ _tool.A_NAME ] ) {
			if ( action[ _tool.A_ORDER ] == odr ) {
				return action ;
			}
		} else {
			for ( var cnt = 0 ; cnt < action.length ; cnt++ ) {
				if ( action[ cnt ][ _tool.A_ORDER ] == odr ) {
					return action[ cnt ] ;
				}
			}
		}
	}
	return null ;
}

_tool.StageManager.prototype.getActionArray = function( odr ) {
	var len = this.countAction() ;
	var ret = [] ;
	for ( var odr = 1 ; odr <= len ; odr++ ) {
		ret.push( this.getAction( odr ) ) ;
	}
	return ret ;
}

_tool.StageManager.prototype.countAction = function( odr ) {
	var action = this._data[ _tool.E_ACTION ] ;
	if ( action == null ) {
		return 0 ;
	} else if ( action[ _tool.A_NAME ] ) {
		return 1 ;
	}
	return action.length ;
}

// for sensor joint stage
_tool.StageManager.prototype.getPropertyData = function( odr , conftyp , k ) {
    var conf = this.getConfig( odr , conftyp ) ;
    if ( conf ) {
        return _tool.getProperty( conf , k ) ;
    }
    return null ;
}
_tool.StageManager.prototype.getConfig = function( odr , type ) {
    var action = this.getAction( odr ) ;
    if ( action ) {
        var conf = action[ _tool.E_CONFIG ] ;
        if ( conf ) {
            if ( conf[ _tool.A_TYPE ] == type ) {
                return conf ;
            } else {
                for ( var cnt = 0 ; cnt < conf.length ; cnt++ ) {
                    if ( conf[cnt][ _tool.A_TYPE ] == type ) {
                        return conf[cnt] ;
                    }
                }
            }
        }
    }
    return null ;
};

// for filter stage
_tool.StageManager.prototype.getActionPropertyData = function( odr , k ) {
	var act = this.getAction( odr ) ;
	if ( act ) {
		return _tool.getProperty( act , k ) ;
	}
    return null ;
}

_tool.StageManager.prototype.getConfigProperty = function( k ) {
	var conf = this.getConfigData() ;
	if ( conf ) {
		var v = _tool.getProperty( conf , k ) ;
		if ( v ) {
			return v[ _tool.A_VALUE ] ;
		}
	}
	return null ;
}
_tool.StageManager.prototype.getConfigData = function() {
	return this._data[ _tool.E_CONFIG ] ;
}


// propertymanager
_tool.PropertyManager = function() {
	this._data ;
	eval( "this._data = " + PipelineData.toString() + ";"  ) ;
	this._sensorMgr = new _tool.StageManager() ;
	this._filterMgr = new _tool.StageManager() ;
	this._jointMgr = new _tool.StageManager() ;
	if ( this._data[_tool.E_TASK] && this._data[ _tool.E_TASK ][ _tool.E_STAGE ] ) {
		var stg = this._data[ _tool.E_TASK ][ _tool.E_STAGE ] ;
		var mgr ;
		for ( var cnt = 0 ; cnt < stg.length ; cnt++ ) {
			if ( stg[cnt][_tool.A_NAME] == "sensor" ) {
				mgr = this.getManager( _tool.ActionPackHelper.ACTION_PRESTAGE ) ;
			} else if ( stg[cnt][_tool.A_NAME] == "filter" ) {
				mgr = this.getManager( _tool.ActionPackHelper.ACTION_MAINSTAGE ) ;
			} else if ( stg[cnt][_tool.A_NAME] == "joint" ) {
				mgr = this.getManager( _tool.ActionPackHelper.ACTION_POSTSTAGE ) ;
			}
			mgr.setData( stg[cnt] ) ;
		}
	}
}

_tool.PropertyManager.prototype.hoistEditFlag = function() {}

_tool.PropertyManager.prototype.getPipelineId = function() {
	return this._data[ _tool.E_TASK ][ _tool.A_ID ] ;
};
_tool.PropertyManager.prototype.getPipelineName = function() {
	return this.getTaskAttribute( _tool.A_NAME ) ;
};

_tool.PropertyManager.prototype.getManager = function(stg) {
	if ( stg == _tool.ActionPackHelper.ACTION_GENERAL || stg == _tool.ActionPackHelper.ACTION_GENERAL_CONFIG ) {
		return this ;
	} else if ( stg == _tool.ActionPackHelper.ACTION_PRESTAGE ) {
		return this._sensorMgr ;
	} else if ( stg == _tool.ActionPackHelper.ACTION_MAINSTAGE || stg == _tool.ActionPackHelper.ACTION_MAINSTAGE_CONFIG ) {
		return this._filterMgr ;
	} else if ( stg == _tool.ActionPackHelper.ACTION_POSTSTAGE ) {
		return this._jointMgr ;
	}
	return null ;
}

_tool.PropertyManager.prototype.getProperty = function( k ) {
	var p = this.getPropertyObject(k) ;
	return (p==null)?null:p[_tool.A_VALUE] ;
};
_tool.PropertyManager.prototype.getPropertyObject = function( k ) {
	return _tool.getProperty( this._data[ _tool.E_TASK ] , k ) ;
};

_tool.PropertyManager.prototype.getTaskAttribute = function( attr ) {
	return this._data[ _tool.E_TASK ][ attr ] ;
};

_tool.PropertyManager.prototype.getConfigProperty = function( conftyp , k ) {
	var conf = this.getConfig( conftyp ) ;
	if ( conf ) {
		var prop = conf[ _tool.E_PROP ] ;
		if ( prop ) {
			if ( prop[ _tool.A_NAME ] ) {
				if ( prop[ _tool.A_NAME ] == k ) {
					return prop ;
				}
			} else {
				for ( var cnt = 0 ; cnt < prop.length ; cnt++ ) {
					if ( prop[cnt][ _tool.A_NAME ] == k ) {
						return prop[cnt] ;
					}
				}
			}
		}
	}
	return null ;
}

_tool.PropertyManager.prototype.getFieldsData = function( fldsnm ) {
	var inf = this.getInterface() ;
	var flds = inf[ _tool.E_FIELDS ] ;
	if ( flds ) {
		if ( flds[ _tool.A_NAME ] ) {
			if ( fldsnm == flds[ _tool.A_NAME ] ) {
				return flds ;
			}
		} else {
			for ( var cnt = 0 ; cnt < flds.length ; cnt++ ) {
				if ( flds[cnt][ _tool.A_NAME ] == fldsnm ) {
					return flds[cnt] ;
				}
			}
		}
	}
	return null ;
}

_tool.PropertyManager.prototype.getField = function( fldsnm , fnm ) {
	var flds = this.getFieldsData( fldsnm ) ;
	if ( flds ) {
		var fld = flds[ _tool.E_FIELD ] ;
		if ( fld ) {
			if ( fld[ _tool.A_NAME ] ) {
				if ( fld[ _tool.A_NAME ] == fnm ) {
					return fld ;
				}
			} else {
				for ( var cnt = 0 ; cnt < fld.length ; cnt++ ) {
					if ( fld[cnt][_tool.A_NAME] == fnm ) {
						return fld[cnt] ;
					}
				}
			}
		}
	}
}

_tool.PropertyManager.prototype.getFieldsAttribute = function( fldsnm ) {
	var flds = this.getFieldsData( fldsnm ) ;
	if ( flds ) {
		return flds[ _tool.E_ATTRIBUTE ] ;
	}
	return null ;
}

_tool.PropertyManager.prototype.addFields = function( fldsnm , ftyp , dspk , opt ) {
	var flds = this.getFieldsData( fldsnm ) ;
	if ( flds == null ) {
		var inf = this.getInterface() ;
		var aflds = { name : fldsnm , type : ftyp , dispkey : dspk } ;
		flds = inf[ _tool.E_FIELDS ] ;
		if ( flds == null ) {
			inf[ _tool.E_FIELDS ] = aflds ;
		} else if ( flds[ _tool.A_NAME ] ) {
			inf[ _tool.E_FIELDS ] = [ flds , aflds ] ;
		} else {
			flds.push( aflds ) ;
		}
		if ( opt ) {
			_tool.copyObjectProperty( aflds , opt ) ;
		}
		return aflds ;
	}
	return flds ;
}

_tool.PropertyManager.prototype.removeField = function( flds , fnm ) {
	var flds = this.getFieldsData( flds ) ;
	var fld ;
	if ( flds ) {
		fld = flds[ _tool.E_FIELD ] ;
		if ( fld == null ) {
		} else if ( fld[ _tool.A_NAME ] ) {
			if ( fld[ _tool.A_NAME ] == fnm ) {
				flds[ _tool.E_FIELD ] = null ;
			}
		} else {
			var tmp = [] ;
			for ( var cnt = 0 ; cnt < fld.length ; cnt++ ) {
				if ( fld[cnt][_tool.A_NAME] == fnm ) {
					delete fld[cnt] ;
				} else {
					tmp.push( fld[cnt] ) ;
				}
			}
			flds[ _tool.E_FIELD ] = tmp ;
		}
	}
}

_tool.PropertyManager.prototype.getInterface = function( ) {
	return this._data[ _tool.E_TASK ][ _tool.E_INTERFACE ] ;
};

_tool.PropertyManager.prototype.getConfig = function( type ) {
	var conf = this._data[ _tool.E_TASK ][ _tool.E_CONFIG ] ;
	if ( conf ) {
		if ( conf[ _tool.A_TYPE ] ) {
			if ( conf[ _tool.A_TYPE ] == type ) {
				return conf ;
			}
		} else {
			for ( var cnt = 0 ; cnt < conf.length ; cnt++ ) {
				if ( conf[cnt][ _tool.A_TYPE ] == type ) {
					return conf[cnt] ;
				}
			}
		}
	}
	return null ;
} ;

_tool.propertymanager = new _tool.PropertyManager() ;


// literalManager

function LiteralBundle() {}
LiteralBundle.prototype.getLiteral = function( akey ) {
	return LiteralMap.get( akey ) ;
};
util.LiteralBundle = new LiteralBundle() ;

function ImageBundle(){};
ImageBundle.prototype.getImagePath = function( akey ) {return "" ;};
util.ImageBundle = new ImageBundle() ;


// EOF// main widget

function Widget() {
	Target.call(this);
	this._children = [] ;
	this.setVisible(true) ;
}

Widget.extend( Target, "Widget" );

Widget.Visible="Visible" ;

Widget.addPropertyField({ "name" : "top"  });
Widget.addPropertyField({ "name" : "left" });
Widget.addPropertyField({ "name" : "right" });
Widget.addPropertyField({ "name" : "bottom" });
Widget.addPropertyField({ "name" : "width" });
Widget.addPropertyField({ "name" : "height" });

Widget.prototype.getChildren = function() { return this._children ; }
Widget.prototype.getChildrenLength = function() { this._children.length ; }
Widget.prototype.hasChildren = function() { return this.getChildrenLength() > 0 ;}
Widget.prototype.indexOf = function( child ) {
	for (var ii = 0 ; ii < this._children.length ; ii++) {
		if ( this._children[ii] == child ) {
			return ii ;
		}
	}
	return -1 ;
}

Widget.prototype.setVisible = function(flg ) {
	this.setUserData(Widget.Visible,flg);
};
Widget.prototype.isVisible = function() {
	return this.getUserData(Widget.Visible);
};

Widget.prototype.add = function() {
	var wdgt ;
	for ( var ii = 0 ; ii < arguments.length ; ii++ ) {
		wdgt = arguments[ii];
		var idx = this.indexOf( wdgt ) ;
		if ( idx != -1 ) {
			this.removeAt( idx ) ;
		}
		this._children.push( wdgt ) ;
		wdgt.setParent( this ) ;
	}
}


Widget.prototype.addAt = function(child,idx) {
	if ( this == child.getParent() ) {
		var oldidx = this.indexOf( child ) ;
		if ( oldidx != idx ) {
			this.removeAt( oldidx ) ;
		}
	} else {
		child.setParent(this) ;
	}
	this._children.splice( idx , 0 , child ) ;
}

Widget.prototype.remove = function() {
	var wdgt ;
	var idx ;
	for (var ii = 0 ; ii < arguments.length ; ii++) {
		wdgt = arguments[ii] ;
		idx = this.indexOf( wdgt ) ;
		if ( idx != -1 ) {
			this.removeAt(idx) ;
		}
	}
}

Widget.prototype.removeAt = function(idx) {
	var ch = this._children[idx] ;
	if ( ch ) {
		ch.setParent(null) ;
		return this._children.splice(idx,1) ;
	}
	return null ;
};

Widget.prototype.removeAllItems = function() {} ;

Widget.prototype.setOverflow = function() {};
Widget.prototype.setCssClassName = function() {};
Widget.prototype.setLayoutHeight = function() {};
Widget.prototype.set = function() {};
Widget.prototype.setToolTip = function() {};

// EOF// layout manager

// interchageable class

function QxCanvasLayout() {Widget.call(this) ;}
QxCanvasLayout.extend(Widget,"QxCanvasLayout") ;


function BoxLayout(vOrientation) {Widget.call(this);};
BoxLayout.extend(Widget, "BoxLayout");

function VerticalBoxLayout(vOrientation) {BoxLayout.call(this,1);};
VerticalBoxLayout.extend( BoxLayout , "VerticalBoxLayout");

function QxHorizontalBoxLayout() {BoxLayout.call(this,0);}
QxHorizontalBoxLayout.extend(BoxLayout,"QxHorizontalBoxLayout") ;
function QxVerticalBoxLayout() {BoxLayout.call(this,1);}
QxVerticalBoxLayout.extend(BoxLayout,"QxVerticalBoxLayout") ;

// for pipeline class

function AbstractActionLayout( libname , odr ) {
    QxCanvasLayout.call( this ) ;
    this.setUserData( AbstractActionLayout.ACTION_NAME, libname ) ;
    this.setUserData( AbstractActionLayout.ACTION_ORDER , odr ) ;
}

AbstractActionLayout.extend( QxCanvasLayout, "AbstractActionLayout" ) ;
AbstractActionLayout.ACTION_NAME = "__ANAME__" ;
AbstractActionLayout.ACTION_ORDER = "__AORDER__" ;

AbstractActionLayout.prototype.getActionName = function() {
    return this.getUserData( AbstractActionLayout.ACTION_NAME ) ;
}

AbstractActionLayout.prototype.getStageType = function() {
    return -1 ;
}

AbstractActionLayout.prototype.setActionOrder = function( odr ) {
	this.setUserData( AbstractActionLayout.ACTION_ORDER , odr ) ;
}

AbstractActionLayout.prototype.getActionOrder = function() {
    return this.getUserData( AbstractActionLayout.ACTION_ORDER ) ;
}

AbstractActionLayout.prototype.setActionOrderValue = function( odr ) {
    this.setUserData( AbstractActionLayout.ACTION_ORDER , odr ) ;
};

AbstractActionLayout.prototype.getLabelString = function( ) {
    return _tool.ActionPackHelper.getActionName( this.getStageType() , this.getActionName() );
};

AbstractActionLayout.prototype.setupProperties = function() {
};

AbstractActionLayout.prototype.buildData = function() {
};

AbstractActionLayout.prototype.buildHiddenData = function() {
};

AbstractActionLayout.prototype.verify = function() {
};

AbstractActionLayout.prototype.createVerifiedData = function() {
};

AbstractActionLayout.prototype.getActionData = function() {
	var part = new Part( this.getActionName() , this.getLabelString() ) ;
	var grp = _tool.ActionPackHelper.getActionGroup( this.getStageType() , this.getActionName() ) ;
	if ( grp ) {
		part.setGroup(grp["group"]) ;
	}
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length ; cc++ ) {
		part.addChild( ch[cc].getActionData() ) ;
	}
	return part ;
};

function AbstractPropertyLayout( vOrientation ) {
    BoxLayout.call( this , vOrientation ) ;
}

AbstractPropertyLayout.extend( BoxLayout , "AbstractPropertyLayout" ) ;

AbstractPropertyLayout.prototype.getActionClass = function( ) {
    return this.getParent() ;
}

AbstractPropertyLayout.prototype.setupProperties = function( ) {
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length  ; cc++ ) {
		ch[cc].setupProperties() ;
	}
}

AbstractPropertyLayout.prototype.buildData = function( ) {

}

AbstractPropertyLayout.prototype.getStage = function() {
    return this.getParent().getStageType() ;
}

AbstractPropertyLayout.prototype.getAction = function() {
    return this.getParent().getActionName() ;
}

AbstractPropertyLayout.prototype.getActionOrder = function() {
    return this.getParent().getActionOrder() ;
}

AbstractPropertyLayout.prototype.getConfigType = function() {
    return null ;
}

// prestage poststage base action
function BaseConfigAction( libname , odr ) {
    AbstractActionLayout.call( this, libname , odr ) ;
}

BaseConfigAction.extend( AbstractActionLayout, "BaseConfigAction" ) ;

BaseConfigAction.DETAIL_MARGIN_HEIGHT = 80 ;

BaseConfigAction.prototype.addConfigProperty = function( a ) {
    this.add( a ) ;
}

BaseConfigAction.prototype.buildData = function() {
    var mgr = _tool.propertymanager.getManager( this.getStageType() ) ;
    mgr.addAction( this.getActionName() , this.getActionOrder() ) ;
    var ch = this.getBodyChildren() ;
    for ( var kk = 0 ; kk < ch.length ; kk++ ) {
        ch[kk].buildData() ;
    }
    this.buildHiddenData() ;
}

BaseConfigAction.prototype.setupProperties = function() {
    var ch = this.getChildren() ;
	var len = ch.length ;
    for ( var cnt = 0 ; cnt < len ; cnt++ ) {
        ch[cnt].setupProperties() ;
    }
}


// prestage action
function BasePrestageAction( libname , odr ) {
    BaseConfigAction.call( this , libname , odr ) ;
    this.setOverflow("auto");
}

BasePrestageAction.extend( BaseConfigAction, "BasePrestageAction" ) ;

BasePrestageAction.prototype.getStageType = function() {
    return _tool.ActionPackHelper.ACTION_PRESTAGE ;
}

function BasePoststageAction( libname , odr ) {
    BaseConfigAction.call( this, libname, odr ) ;
    this.setCssClassName( "actionLayoutPane" ) ;
}

BasePoststageAction.extend( BaseConfigAction, "BasePoststageAction" ) ;
BasePoststageAction.prototype.getStageType = function() {
    return _tool.ActionPackHelper.ACTION_POSTSTAGE ;
}

function BaseMainAction( libname , odr ) {
    AbstractActionLayout.call( this , libname, odr ) ;
}

BaseMainAction.extend( AbstractActionLayout, "BaseMainAction" ) ;

BaseMainAction.prototype.getStageType = function() {
    return _tool.ActionPackHelper.ACTION_MAINSTAGE ;
};

BaseMainAction.prototype.addBody = function(c) {
	this.add(c) ;
};
BaseMainAction.prototype.setBodyHeight = function(h) {
	this.setUserData("BODYHEIGHT",h) ;
};
BaseMainAction.prototype.setupProperties = function( ) {
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length  ; cc++ ) {
		ch[cc].setupProperties() ;
	}
} ;

//
function ActionLabelLayout( stg ) {
    AbstractPropertyLayout.call( this, 1 , stg ) ;
}

ActionLabelLayout.extend( AbstractPropertyLayout , "ActionLabelLayout" ) ;

ActionLabelLayout.prototype.addProperty = function( prop ) {
	if ( ! prop ) return ;
    this.add( prop ) ;
}

ActionLabelLayout.prototype.getStage = function( ) {
    return this.getParent().getStage() ;
}

ActionLabelLayout.prototype.getActionOrder = function( ) {
    return this.getParent().getActionOrder() ;
}

ActionLabelLayout.prototype.getConfigType = function( ) {
    return this.getParent().getConfigType() ;
}

function ActionGroupLayout( lbl , stg , cfg ) {
	AbstractPropertyLayout.call(this , 1) ;
	this.setUserData("CaptionLabel",util.LiteralBundle.getLiteral( lbl ) ) ;
	this.setUserData("ConfigType",cfg) ;
}
ActionGroupLayout.extend( AbstractPropertyLayout , "ActionGroupLayout" ) ;
ActionGroupLayout.prototype.addProperty = function(c) {
	if (!c) return ;
	this.add(c) ;
}
ActionGroupLayout.prototype.getConfigType = function(c) {
	return this.getUserData("ConfigType") ;
}
ActionGroupLayout.prototype.getLabel = function(c) {
	return this.getUserData("CaptionLabel");
}

ActionGroupLayout.prototype.getActionData = function() {
	var part = new Part( this.getConfigType() , this.getLabel() , true ) ;
	var map = new LinkedHashMap() ;
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length  ; cc++ ) {
		if ( ch[cc].isVisible() ) {
			ch[cc].putActionData( map ) ;
		}
	}
	part.setProperties( map ) ;
	return part ;
};

function ActionVerticalLayout( stg ) {
	AbstractPropertyLayout.call(this , 1) ;
};
ActionVerticalLayout.extend( AbstractPropertyLayout , "ActionVerticalLayout" ) ;
ActionVerticalLayout.prototype.addProperty = function(c) {
	if (!c) return ;
	this.add(c) ;
};

ActionVerticalLayout.prototype.getActionData = function() {
	var part = new Part( "" , "" ) ;
	var map = new LinkedHashMap() ;
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length  ; cc++ ) {
		if ( ch[cc].isVisible() ) {
			ch[cc].putActionData( map ) ;
		}
	}
	part.setProperties( map ) ;
	return part ;
};


// EOF
// basic control

function ActionControl( vParam ) {
	Widget.call(this) ;

	// Width , Height
	// controltype , name , value , required , validatetype , checked
	// MacroType , MacroPosition , ReadOnly , MacroAccept
	if ( vParam.width ) {
		this.setWidth( vParam.width ) ;
	}
	if ( vParam.height ) {
		this.setHeight( vParam.height ) ;
	}
	var widget = vParam.wedget ? vParam.wedget : vParam.widget ;
	this.setUserData( ActionControl.ControlType , widget ) ;
	this.setUserData( ActionControl.ActionName , vParam.name ) ;
	this.setUserData( ActionControl.ActionValue , vParam.value == null ? "" : vParam.value ) ;
	this.setUserData( ActionControl.Required , vParam.required ) ;
	this.setUserData( ActionControl.ValidateType , vParam.validatetype ) ;
	this.setUserData( ActionControl.Checked , vParam.checked ) ;
	this.setUserData( ActionControl.Text , vParam.text ) ;
	this.setUserData( ActionControl.MacroType , vParam.macrotype ) ;
	this.setUserData( ActionControl.MacroPosition , vParam.position ) ;
	this.setUserData( ActionControl.ReadOnly , vParam.readonly ) ;
	this.setUserData( ActionControl.MacroAccept , vParam.accept ) ;
	if ( vParam.list ) {
		var lst = vParam.list ;
		for ( var cc = 0 ; cc < lst.length ; cc++ ) {
			var p = lst[cc] ; p["wedget"] = widget ;
			this.add( new ActionControl( p ) ) ;
		}
	}
}

ActionControl.extend( Widget , "ActionControl" ) ;

ActionControl.ControlType = "WidgetType" ;
ActionControl.ActionName = "ActionName" ;
ActionControl.ActionValue = "ActionValue" ;
ActionControl.Required = "Required" ;
ActionControl.ValidateType = "ValidateType" ;
ActionControl.Checked = "Checked" ;
ActionControl.Text = "text" ;
ActionControl.MacroType = "MacroType" ;
ActionControl.MacroPosition = "MacroPosition" ;
ActionControl.ReadOnly = "ReadOnly" ;
ActionControl.MacroAccept = "MacroAccept" ;

ActionControl.prototype.buildVariable = function( ) {

}

ActionControl.prototype.getActionText = function() {
	return this.getUserData(ActionControl.Text);
};

ActionControl.prototype.loadVariable = function() {
	var stg = this.getParent().getStage() ;
	var odr = this.getParent().getActionOrder() ;
	var cfg = this.getParent().getConfigType() ;
    var mgr = _tool.propertymanager.getManager( stg ) ;
	var pnm = this.getName() ;
	var value = null ;
    if ( mgr ) {
        if ( stg == _tool.ActionPackHelper.ACTION_MAINSTAGE ) {
            value = mgr.getActionPropertyData( odr , pnm ) ;
        } else if ( stg == _tool.ActionPackHelper.ACTION_GENERAL_CONFIG ) {
            value = mgr.getConfigProperty( cfg , pnm ) ;
        } else if ( stg == _tool.ActionPackHelper.ACTION_GENERAL ) {
            value = mgr.getPropertyObject( pnm ) ;
        } else if ( stg == _tool.ActionPackHelper.ACTION_PRESTAGE || stg == _tool.ActionPackHelper.ACTION_POSTSTAGE ) {
            value = mgr.getPropertyData( odr , cfg , pnm ) ;
        }
	}
	if ( value ) {
		if ( value.isnull == "true" ) {
			this.setUserData( ActionControl.ActionValue , "" ) ;
		} else {
			this.setUserData( ActionControl.ActionValue , value["value"] ) ;
		}
	} else {
		this.setUserData( ActionControl.ActionValue , "" ) ;
	}
	return value ;
}

ActionControl.prototype.getControlType = function() {
	return this.getUserData(ActionControl.ControlType) ;
}

ActionControl.prototype.getName = function() {
	return this.getUserData(ActionControl.ActionName) ;
}

ActionControl.prototype.getValue = function() {
	return this.getUserData(ActionControl.ActionValue) ;
}

ActionControl.prototype.setValue = function(v) {
	this.setUserData(ActionControl.ActionValue,v) ;
}

ActionControl.prototype.isRequired = function() {
	return this.getUserData(ActionControl.Required) ;
}

ActionControl.prototype.validateType = function() {
	return this.getUserData(ActionControl.ValidateType);
}

ActionControl.prototype.isChecked = function() {
	return this.getUserData(ActionControl.Checked);
}

ActionControl.prototype.isReadOnly = function() {
	return this.getUserData(ActionControl.ReadOnly);
}

ActionControl.prototype.macroType = function() {
	return this.getUserData(ActionControl.MacroType);
}

ActionControl.prototype.macroPosition = function() {
	return this.getUserData(ActionControl.MacroPosition);
}

ActionControl.prototype.macroAccept = function() {
	return this.getUserData(ActionControl.MacroAccept);
};

ActionControl.prototype.setActionData = function( lst ) {
	if ( this.isVisible() ) {
		this.setLabel( lst ) ;
	}
} ;
ActionControl.prototype.setLabel = function( lst ) {lst.add( this.getValue() );};

// ActionText , ActionTextArea , ActionComboBox , ActionCheckBox , ActionRadioButton
// ActionPassword , MacroText , MacroTextArea , ActionButton , ActionLabel 
function ActionText( p ) {
	ActionControl.call( this , p ) ;
}
ActionText.extend( ActionControl , "ActionText" ) ;
function ActionTextArea( p ) {
	ActionControl.call( this , p ) ;
}
ActionTextArea.extend( ActionControl , "ActionTextArea" ) ;
ActionTextArea.prototype.setLabel = function( lst ) {lst.add( this.getValue() );};

function WpCombobox( p ) {
	ActionControl.call( this , p ) ;
}
WpCombobox.extend( ActionControl , "WpCombobox" ) ;
WpCombobox.prototype.findItem = function( val ) {
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length ; cc++ ) {
		if ( ch[cc].getValue() == val ) {
			return ch[cc] ;
		}
	}
	return null ;
};
WpCombobox.prototype.setLabel = function( lst ) {
	var val = "" ;
	var itm = this.findItem( this.getValue() ) ;
	if ( itm ) {
		val = itm.getName() ;
	}
	lst.add( val );
};
WpCombobox.prototype.setChangeListener = function() {};
function ActionComboBox( p ) {
	WpCombobox.call( this , p ) ;
}
ActionComboBox.extend( WpCombobox , "ActionComboBox" ) ;

function ActionCheckBox( p ) {
	ActionControl.call( this , p ) ;
}
ActionCheckBox.extend( ActionControl , "ActionCheckBox" ) ;
ActionCheckBox.prototype.setLabel = function( lst ) {
	var val = this.getValue() ;
	if (!val) val = "false" ;
	var txt = this.getActionText() ;
	if ( txt ) {
		lst.add( txt + "[" +toFirstUp( val ) + "]" );
	} else {
		lst.add( toFirstUp( val ) );
	}
};

function ActionRadioButton( p ) {
	ActionControl.call( this , p ) ;
};
ActionCheckBox.prototype.setLabel = function( lst ) {
	var val = this.getValue() ;
	if (!val) val = "false" ;
	var txt = this.getActionText() ;
	if ( txt ) {
		lst.add( txt + "[" +toFirstUp( val ) + "]" );
	} else {
		lst.add( toFirstUp( val ) );
	}
};
ActionRadioButton.extend( ActionControl , "ActionRadioButton" ) ;
ActionRadioButton.prototype.findItem = function( val ) {
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length ; cc++ ) {
		if ( ch[cc].getValue() == val ) {
			return ch[cc] ;
		}
	}
	return null ;
};
ActionRadioButton.prototype.setLabel = function( lst ) {
	var val = this.getValue() ;
	if (!val) {
		lst.add( this.getActionText() ) ;
		return ;
	}
	var itm = this.findItem( val ) ;
	if ( itm ) {
		lst.add( itm.getActionText() ) ;
	} else {
		lst.add( this.getActionText() ) ;
	}
};

function ActionPassword( p ) {
	ActionControl.call( this , p ) ;
};
ActionPassword.extend( ActionControl , "ActionPassword" ) ;
ActionPassword.prototype.setLabel = function( lst ) {lst.add( "****" );};

function MacroText( ) {
	var param ;
	if ( arguments.length > 1 ) {
		param = {} ;
		param[ "widget" ] = "macrotext" ;
		param[ "name" ] = arguments[0] ;
		param[ "value" ] = arguments[1];
		param[ "required" ] = arguments[2];
		param[ "validatetype" ] = arguments[3];
		param[ "macrotype" ] = arguments[4];
		param[ "position" ] = arguments[5];
		param[ "readonly" ] = arguments[6];
		param[ "accept" ] = arguments[7];
	} else {
		param = arguments[0] ;
	}
	ActionControl.call( this , param ) ;
};
MacroText.extend( ActionControl , "MacroText" ) ;
MacroText.prototype.setLabel = function( lst ) {
	var txt = this.getValue() ;
	if ( txt ) {
		txt = _tool.decodeMacro( txt ) ;
	} else {
		txt = "" ;
	}
	lst.add( txt );
};
function MacroTextArea( p ) {
	ActionControl.call( this , p ) ;
};
MacroTextArea.extend( ActionControl , "MacroTextArea" ) ;
MacroTextArea.prototype.setLabel = function( lst ) {
	var txt = this.getValue() ;
	if ( txt ) {
		txt = _tool.decodeMacro( txt ) ;
	} else {
		txt = "" ;
	}
	lst.add( txt );
};
function ActionButton( p ) {
	ActionControl.call( this , p ) ;
}
ActionButton.extend( ActionControl , "ActionButton" ) ;
function ActionLabel( p ) {
	if ( ! p["name"] ) {
		p = { "name":"label" ,"value":p , "text":p } ;
	}
	ActionControl.call( this , p ) ;
}
ActionLabel.extend( ActionControl , "ActionLabel" ) ;
ActionLabel.prototype.loadVariable = function() {};
ActionLabel.prototype.setLabel = function(lst) { lst.add( this.getActionText() ); };

function ActionMappingItem() {
	ActionControl.call( this , {} ) ;
	this.mapping = null ;
};
ActionMappingItem.extend( ActionControl , "ActionMappingItem" ) ;
ActionMappingItem.prototype.setMappingData = function( map ) {
	this.mapping = map ;
	this.setUserData( "FROM", _tool.decodeMacro( map.Input.value==null?"":map.Input.value ) );
	this.setUserData( "TO"  , _tool.decodeMacro( map.Output.value==null?"":map.Output.value ) );
	var m = map.Output.value ;
	this.setUserData( "ISSINGLE" , ( m == null || m.length == 0 ) );
};
ActionMappingItem.prototype.getLabel = function( singleLabel , fromLabel , toLabel ) {
	if ( this.getUserData( "ISSINGLE") ) {
		return this.getUserData( "FROM" ) + singleLabel + "\n" ;
	}
	return this.getUserData( "FROM" ) + fromLabel + this.getUserData("TO") + toLabel + "\n" ;
} ;

function ActionMappingControl(vParam) {
	ActionControl.call( this , vParam ) ;
	this.setUserData( "SINGLELABEL" , util.LiteralBundle.getLiteral( vParam.single ) ) ;
	this.setUserData( "FROMLABEL" , util.LiteralBundle.getLiteral( vParam.exchangefrom ) ) ;
	this.setUserData( "TOLABEL" , util.LiteralBundle.getLiteral( vParam.exchangeto ) ) ;
};
ActionMappingControl.extend( ActionControl , "ActionMappingControl" ) ;
ActionMappingControl.prototype.loadVariable = function() {
	var value = ActionControl.prototype.loadVariable.call(this) ;
	if (value) {
		var map = value[ _tool.E_MAP ] ;
		if ( map ) {
			if ( map[ _tool.E_INPUT ] ) {
				this.add( this.createItem( map ) ) ;
			} else {
				for ( var cnt = 0 ; cnt < map.length ; cnt++ ) {
					this.add( this.createItem( map[cnt] ) ) ;
				}
			}
		}
	}
};
ActionMappingControl.prototype.createItem = function( map ) {
	var itm = new ActionMappingItem() ;
	itm.setMappingData( map ) ;
	return itm ;
};
ActionMappingControl.prototype.setLabel = function( lst ) {
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length ; cc++ ) {
		lst.add( ch[cc].getLabel( this.getUserData("SINGLELABEL") , this.getUserData("FROMLABEL") , this.getUserData("TOLABEL") ) ) ;
	}
} ;


function RDBMappingItem() {
	ActionControl.call( this , {} ) ;
	this.mapping = null ;
};
RDBMappingItem.extend( ActionControl , "RDBMappingItem" ) ;
RDBMappingItem.prototype.setMappingData = function( map ) {
	this.mapping = map ;
	this.setUserData( "FROM", ( map.Input.name==null?"":map.Input.name ) );
	this.setUserData( "TO"  , _tool.decodeMacro( map.Input.value==null?"":map.Input.value ) );
	this.setUserData( "ISPK" , map.Output.value == "true" );
};
RDBMappingItem.prototype.getLabel = function( singleLabel , fromLabel , toLabel ) {
	return this.getUserData("FROM") + " / " + this.getUserData( "TO" ) + (this.getUserData( "ISPK") ?" PK\n":"\n") ;
} ;

function RDBMappingTable( nm, isDel ) {
	ActionMappingControl.call( this,{"name":nm} ) ;
}

RDBMappingTable.extend(ActionMappingControl,"RDBMappingTable") ;
RDBMappingTable.prototype.createItem = function( map ) {
	var itm = new RDBMappingItem() ;
	itm.setMappingData( map ) ;
	return itm ;
};
RDBMappingTable.prototype.setLabel = function( lst ) {
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length ; cc++ ) {
		lst.add( ch[cc].getLabel( this.getUserData("SINGLELABEL") , this.getUserData("TOLABEL") ) ) ;
	}
} ;

function MultiFieldItem() {
	ActionControl.call( this , {} ) ;
	this.mapping = null ;
};
MultiFieldItem.extend( ActionControl , "MultiFieldItem" ) ;
MultiFieldItem.prototype.setMappingData = function( input ) {
	this.mapping = input ;
	this.setUserData("FIELD", _tool.decodeMacro( input.value==null?"":input.value ) ) ;
};
MultiFieldItem.prototype.getLabel = function( singleLabel , fromLabel ) {
	return this.getUserData("FIELD") + "\n" ;
} ;

function MultiTable(nm,prop) {
	if ( ! prop ) {
		prop = nm ;
		nm = prop.name ;
	}
	ActionMappingControl.call( this,{"name":nm} ) ;
	this.setUserData( "HEADERLABEL" , prop.headerlabel ? util.LiteralBundle.getLiteral( prop.headerlabel ) : util.LiteralBundle.getLiteral( "label_multitable" ) ) ;
};
MultiTable.extend(ActionMappingControl,"RDBMappingTable") ;
MultiTable.prototype.createItem = function( input ) {
	var itm = new MultiFieldItem() ;
	itm.setMappingData( input ) ;
	return itm ;
};
MultiTable.prototype.loadVariable = function() {
	var value = ActionControl.prototype.loadVariable.call(this) ;
	if (value) {
		var input = value[ _tool.E_INPUT ] ;
		if ( input ) {
			if ( input[ _tool.A_NAME ] ) {
				this.add( this.createItem( input ) ) ;
			} else {
				for ( var cnt = 0 ; cnt < input.length ; cnt++ ) {
					this.add( this.createItem( input[cnt] ) ) ;
				}
			}
		}
	}
};
MultiTable.prototype.setLabel = function( lst ) {
	lst.add( this.getUserData("HEADERLABEL") + "\n" ) ;
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length ; cc++ ) {
		lst.add( ch[cc].getLabel( ) ) ;
	}
} ;


function InterfaceMappingItem( nm , mp , attrs , typ ) {
	ActionControl.call( this, {"name":nm } ) ;
	this._attributes = [] ;
    if ( attrs ) {
        if ( attrs[ _tool.A_NAME ] ) {
            this._attributes.push( InterfaceMappingItem.createAttributeField( mp ,attrs ) ) ;
        } else {
            for ( var cnt = 0 ; cnt < attrs.length ; cnt++ ) {
                this._attributes.push( InterfaceMappingItem.createAttributeField( mp , attrs[cnt] ) ) ;
            }
        }
    }

};
InterfaceMappingItem.extend( ActionControl , "InterfaceMappingItem" ) ;
InterfaceMappingItem.createAttributeField = function( map , attr ) {
	if ( attr[ _tool.A_WEDGET ] == "text" ) {
		return map[ attr[_tool.A_NAME] ] ;
	} else if ( attr[ _tool.A_WEDGET ] == "checkbox" ) {
		var txt = util.LiteralBundle.getLiteral( attr[ "text" ] ) ;
		var flg = "true" == map[ attr[_tool.A_NAME] ] ? "True" : "False" ;
		if ( txt ) {
			return txt + "[" + flg + "]" ;
		}
		return flg ;
	} else if ( attr[_tool.A_WEDGET] == "macrotext" ) {
		var val = map[ attr[_tool.A_NAME] ] ;
		return _tool.decodeMacro( val ==null?"":val )
	}
	return "" ;
} ;
InterfaceMappingItem.prototype.setMappingData = function( map ) {
	this.mapping = map ;
	this.setUserData("FIELD", map.Input.name ) ;
	var ft = _tool.getFieldType( map.Output.name ) ;
	this.setUserData("FIELDTYPE" , ft == null ? util.LiteralBundle.getLiteral("label_string") : util.LiteralBundle.getLiteral(ft.dispkey) ) ;
};
InterfaceMappingItem.prototype.attributeString = function( ) {
	if ( this._attributes.length == 0 ) return "" ;
	var s = "" ;
	for ( var ii = 0 ; ii < this._attributes.length ; ii++ ) {
		s += " / " + this._attributes[ii] ;
	}
	return s ;
};
InterfaceMappingItem.prototype.getLabel = function( singleLabel , fromLabel ) {
	return this.getUserData("FIELD") + " / " + this.getUserData("FIELDTYPE") + this.attributeString() + "\n" ;
} ;
InterfaceMappingItem.prototype.getTypeString = function(val) {
	var ty = _tool.FIELD_TYPES;
	for ( var vv = 0 ; vv < ty.length ; vv++ ) {
		if ( val == ty[vv].value ) {return util.LiteralBundle.getLiteral( ty[vv].dispkey ) ; }
	}
	return util.LiteralBundle.getLiteral("label_string") ;
};

function InterfaceMappingEditor( aName , aLabel , aAttrs , aWidth , aType ) {
	ActionMappingControl.call( this,{"name":aName,"width":aWidth} ) ;
	this.setUserData( "HEADERLABEL" , aLabel ) ;
	this._attribute = aAttrs ;
	this.setUserData( "FIELDSTYPE" , aType==null?_tool.INTERFACE_RECORD:aType ) ;
};
InterfaceMappingEditor.extend(ActionMappingControl,"InterfaceMappingEditor") ;
InterfaceMappingEditor.prototype.createItem = function( nm , map , attr ) {
	var itm = new InterfaceMappingItem( nm , map , attr , _tool.getFieldType( {"type":this.getUserData("FIELDSTYPE")} ) ) ;
	itm.setMappingData( map ) ;
	return itm ;
};
InterfaceMappingEditor.prototype.loadVariable = function() {
	var value = ActionControl.prototype.loadVariable.call(this) ;
	if ( value ) {
		var map = value[ _tool.E_MAP ] ;
		if ( map ) {
			var attrs = this._attribute ;
			if ( map[ _tool.E_INPUT ] ) {
				this.add( this.createItem( map.Input.name , map , attrs ) ) ;
			} else {
				for ( var cnt = 0 ; cnt < map.length ; cnt++ ) {
					this.add( this.createItem( map[cnt].Input.name , map[cnt] , attrs ) ) ;
				}
			}
		}
	}
};
InterfaceMappingEditor.prototype.setLabel = function( lst ) {
	lst.add( this.getUserData("HEADERLABEL") + "\n" ) ;
	var ch = this.getChildren() ;
	for ( var cc = 0 ; cc < ch.length ; cc++ ) {
		lst.add( ch[cc].getLabel() ) ;
	}
} ;

function LabelFieldMappingFieldItem(  ) {
	ActionControl.call( this , {} ) ;
	this.mapping = null ;
};
LabelFieldMappingFieldItem.extend( ActionControl , "LabelFieldMappingFieldItem" ) ;
LabelFieldMappingFieldItem.prototype.setMappingData = function( map ) {
	this.mapping = map ;
	this.setUserData("FROM", map.Output.name );
	this.setUserData("TO"  , _tool.decodeMacro( map.Input.value==null?"":map.Input.value ) );
};
LabelFieldMappingFieldItem.prototype.getLabel = function( ) {
	return this.getUserData("FROM") + " / " + this.getUserData( "TO" ) + "\n" ;
} ;

function LabelFieldMappingTable( nm , lbl_label , lbl_field , rows, stg ) {
	ActionMappingControl.call( this , {"name":nm,"single": lbl_label ,"exchangefrom": lbl_field } ) ;

};
LabelFieldMappingTable.extend(ActionMappingControl,"LabelFieldMappingTable") ;
LabelFieldMappingTable.prototype.createItem = function( map ) {
	var itm = new LabelFieldMappingFieldItem() ;
	itm.setMappingData( map ) ;
	return itm ;
};
LabelFieldMappingTable.prototype.setLabel = function( lst ) {
	var ch = this.getChildren() ;
	lst.add( this.getUserData("SINGLELABEL") + " / " + this.getUserData( "FROMLABEL" ) + "\n" ) ;
	for ( var cc = 0 ; cc < ch.length ; cc++ ) {
		lst.add( ch[cc].getLabel() ) ;
	}
} ;

// label
function BaseLabelText( stg , lbl , prop ) {
    ActionLabelLayout.call( this , stg ) ;
	this.setUserData( "RowLabel" , util.LiteralBundle.getLiteral( lbl ) ) ;
	this.setUserData( "LabelWidth" , ActionLabelLayout.LABEL_WIDTH ) ;
	this.setUserData( "RowHeight" , BaseLabelText.ROW_HEIGHT ) ;
	this.setUserData( "EasyFlag" , (prop.easy == null || prop.easy == true) ? true : false ) ;
	this.setUserData( "ConfigType" , prop.configtype ) ;
	if ( prop && prop.wedget ) { this.add( new ActionControl( prop ) ) ; }
}

BaseLabelText.extend( ActionLabelLayout , "BaseLabelText" ) ;

BaseLabelText.ROW_HEIGHT = 26 ;

BaseLabelText.prototype.setLabelWidth = function(w) {
	this.setUserData("LabelWidth",w) ;
};
BaseLabelText.prototype.setEasyFlag = function(b) {this.setUserData("EasyFlag",b);};
BaseLabelText.prototype.getLabelString = function() {return this.getUserData( "RowLabel" ) ;}
BaseLabelText.prototype.getInputField = function() {return this.getChildren()[0] ;}
BaseLabelText.prototype.putActionData = function( map ) {
	var lst = new ArrayList() ;
    var ch = this.getChildren() ;
    var len = ch.length ;
    for ( var cnt = 0 ; cnt < len ; cnt++ ) {
		ch[cnt].setActionData( lst ) ;
    }
	map.put( this.getLabelString() , lst ) ;
}

BaseLabelText.prototype.setupProperties = function( ) {
    var ch = this.getChildren() ;
    var len = ch.length ;
    for ( var cnt = 0 ; cnt < len ; cnt++ ) {
        ch[cnt].loadVariable() ;
    }
}

BaseLabelText.prototype.buildData = function( ) {
    var ch = this.getChildren() ;
    var len = ch.length ;
    for ( var cnt = 1 ; cnt < len ; cnt++ ) {
        ch[cnt].buildVariable() ;
    }
}

BaseLabelText.prototype.getConfigType = function() {
	var cfg = this.getUserData( "ConfigType" ) ;
	if ( cfg ) {
		return cfg ;
	}
	return this.getParent().getConfigType() ;
}

// Wrench

var ControlMap = {
	"text" : ActionText ,
	"textarea" : ActionTextArea ,
	"combobox" : ActionComboBox ,
	"checkbox" : ActionCheckBox ,
	"radio" : ActionRadioButton ,
	"password" : ActionPassword ,
	"macrotext" : MacroText ,
	"macroarea" : MacroTextArea ,
	"label" : ActionLabel ,
	"button" : ActionButton ,
	"multitable" : MultiTable
};

_tool.Wrench = new Object() ;

_tool.Wrench.createBaseText = function( stg , lbl , conf , itm ) {
	var ret = new BaseLabelText( stg , lbl , { configtype : conf } ) ;
	if ( itm ) { ret.add( itm ) ; }
	return ret ;
}

_tool.Wrench.create = function() {
	var ret = [] ;
	var len = arguments.length ;
	for ( var kk = 0 ; kk < len ; kk++ ) {
		var prop = arguments[ kk] ;
		var ctl = ControlMap[ prop.wedget ] ;
		if ( ctl ) ret.push( _tool.Wrench.createBaseText( arguments[0] , prop.label , prop.configtype , new ctl( prop ) ) ) ;
	}
	return ret ;
}
/*
_tool.Wrench.createPropDataEditTable = function( stg , lbl , flds ) {
	//var tab = new DataEditTable( flds ) ;
	return _tool.Wrench.createBaseText( stg , lbl , _tool.CONFIG_FIELD , null ) ;
}

_tool.Wrench.createPropMapTable = function( ) {
	var prop = arguments[1] ;
	//var itm = new MappingTable( prop.name , prop ) ;
	var tmp =  _tool.Wrench.createBaseText( arguments[0] , prop.label , prop.configtype , null ) ;
	tmp.setHeight( itm.getHeight() ) ;
	return tmp ;
}
*/

_tool.Wrench.createPropMultiTable = function( ) {
	var prop = arguments[1] ;
	return _tool.Wrench.createBaseText( arguments[0] , prop.label , prop.configtype , new MultiTable( prop.name , prop ) ) ;
} ;

_tool.Wrench.createMacroText = function() {
	var stg = arguments[0] ;
	var ret = new Array() ;
	for ( var kk = 1 ; kk < arguments.length ; kk++ ) {
		var prop = arguments[kk] ; prop["wedget"] = "macrotext" ;
		ret.push( _tool.Wrench.createBaseText( stg , prop.label , prop.configtype , new MacroText( prop ) ) ) ;
	}
	return ret ;
};
_tool.Wrench.createMacroTextArea = function(stg,prop) {
	var stg = arguments[0] ;
	var ret = new Array() ;
	for ( var kk = 1 ; kk < arguments.length ; kk++ ) {
		var prop = arguments[kk] ; prop["wedget"] = "macroarea" ;
		ret.push( _tool.Wrench.createBaseText( stg , prop.label , prop.configtype , new MacroTextArea( prop ) ) ) ;
	}
	return ret ;
};
_tool.Wrench.createEncodingCombobox = function( stg , conftyp , containJisAutoDetect , name , label , easy) {
	if (containJisAutoDetect) {
		return _tool.Wrench.createComboBox( stg ,
				{ name : ( name == null ? "encoding" : name ) , editable : true , label : ( label == null ? "label_encoding" : label ) , configtype : conftyp , easy : (easy == null ? true : easy ) ,
					list : [
						{ name : util.LiteralBundle.getLiteral('label_jis_auto_detect') , value : 'JISAutoDetect' } ,
						{ name : 'utf-8' , value : 'utf-8' } ,
						{ name : 'shift_jis' , value : 'shift_jis' } ,
						{ name : 'euc-jp' , value : 'euc-jp' } ,
						{ name : 'iso-2022-jp' , value : 'iso-2022-jp' } ,
						{ name : 'utf-16' , value : 'utf-16' } ]
				}
			)[0] ;
	}
	return _tool.Wrench.createComboBox( stg ,
				{ name : ( name == null ? "encoding" : name ) , editable : true ,  label : ( label == null ? "label_encoding" : label ) , configtype : conftyp , easy : (easy == null ? true : easy ) ,
					list : [
						{ name : 'utf-8' , value : 'utf-8' } ,
						{ name : 'shift_jis' , value : 'shift_jis' } ,
						{ name : 'euc-jp' , value : 'euc-jp' } ,
						{ name : 'iso-2022-jp' , value : 'iso-2022-jp' } ,
						{ name : 'utf-16' , value : 'utf-16' } ]
				} )[0] ;
};

_tool.Wrench.createText = function( stg , prop ) {
	var stg = arguments[0] ;
	var ret = new Array() ;
	for ( var kk = 1 ; kk < arguments.length ; kk++ ) {
		var prop = arguments[kk] ; prop["wedget"] = "text" ;
		ret.push( _tool.Wrench.createBaseText( stg , prop.label , prop.configtype , new ActionText( prop ) ) ) ;
	}
	return ret ;
};
_tool.Wrench.createCheckBox = function( stg , prop ) {
	var stg = arguments[0] ;
	var ret = new Array() ;
	for ( var kk = 1 ; kk < arguments.length ; kk++ ) {
		var prop = arguments[kk] ; prop["wedget"] = "checkbox" ;
		ret.push( _tool.Wrench.createBaseText( stg , prop.label , prop.configtype , new ActionCheckBox( prop ) ) ) ;
	}
	return ret ;
};
_tool.Wrench.createComboBox = function(stg,prop) {
	var stg = arguments[0] ;
	var ret = new Array() ;
	for ( var kk = 1 ; kk < arguments.length ; kk++ ) {
		var prop = arguments[kk] ; prop["wedget"] = "combobox" ;
		ret.push( _tool.Wrench.createBaseText( stg , prop.label , prop.configtype , new ActionComboBox( prop ) ) ) ;
	}
	return ret ;
};
_tool.Wrench.createPropComboBox = function(stg,prop) {
	prop["wedget"] = "combobox" ;
	return _tool.Wrench.createBaseText( stg , prop.label , prop.configtype , new ActionComboBox( prop ) ) ;
};
_tool.Wrench.createCheckBoxItem = function( ) {
	var ret = new Array() ;
	var stg = arguments[0] ;
	var len = arguments.length ;
	for ( var kk = 1 ; kk < len ; kk++ ) {
		var prop = arguments[ kk] ;
		prop["wedget"] = "checkbox" ;
		if ( ! prop.text ) {prop.text = "" ;}
		if ( ! prop.checked ) {	prop.checked = false ;}
		var c = new ActionCheckBox( prop ) ;
		ret.push( c ) ;
	}
	return ret ;
};

_tool.Wrench.createPropExchanger = function( ) {
	var prop = arguments[1] ;
	var labelSet = prop.labelset ;
	if ( labelSet ) {
		prop["single"] = labelSet["single"] ;
		prop["exchangefrom"] = labelSet["exchangefrom"] ;
		prop["exchangeto"] = labelSet["exchangeto"] ;
	} else {
		prop["single"] = "label_exchange_this" ;
		prop["exchangefrom"] = "label_wo" ;
		prop["exchangeto"] = "label_exchange_to" ;
	}
	var ret = _tool.Wrench.createBaseText( arguments[0] , "MSG_EMPTY" , prop.configtype , new ActionMappingControl( prop ) ) ;
	ret.setLabelWidth( 5 ) ;
	return ret ;
};

_tool.Wrench.createPropSummrize = function( ) {
	var prop = arguments[1] ;
	var labelSet = prop.labelset ;
	if ( labelSet ) {
		prop["single"] = labelSet["single"] ;
		prop["exchangefrom"] = labelSet["exchangefrom"] ;
		prop["exchangeto"] = labelSet["exchangeto"] ;
	} else {
		prop["single"] = "label_exchange_this" ;
		prop["exchangefrom"] = "label_wo" ;
		prop["exchangeto"] = "label_exchange_to_map" ;
	}
	var ret = _tool.Wrench.createBaseText( arguments[0] , "MSG_EMPTY" , prop.configtype , new ActionMappingControl( prop ) ) ;
	ret.setLabelWidth( 5 ) ;
	return ret ;
};

_tool.Wrench.createPropMapper = function( ) {
	var prop = arguments[1] ;
	var labelSet = prop.labelset ;
	if ( labelSet ) {
		prop["single"] = labelSet["single"] ;
		prop["exchangefrom"] = labelSet["exchangefrom"] ;
		prop["exchangeto"] = labelSet["exchangeto"] ;
	} else {
		prop["single"] = "label_exchange_this" ;
		prop["exchangefrom"] = "label_wo" ;
		prop["exchangeto"] = "label_exchange_to_map" ;
	}
	var ret = _tool.Wrench.createBaseText( arguments[0] , "MSG_EMPTY" , prop.configtype , new ActionMappingControl( prop ) ) ;
	ret.setLabelWidth( 5 ) ;
	return ret ;
};

_tool.Wrench.createFieldViewer = function( ) {
	return null ;
};

_tool.Wrench.createFieldMappingEditor = function( ) {
	var prop = arguments[1] ;
	var ret = _tool.Wrench.createBaseText( arguments[0] , "MSG_EMPTY" , prop.configtype , new InterfaceMappingEditor( prop.name , prop.headerlabel , prop.attributes , prop.width , prop.fieldstype  ) ) ;
	ret.setLabelWidth( 5 ) ;
	return ret ;
};

function QxToolTip() {Widget.call(this) ;};
QxToolTip.extend( Widget , "QxToolTip" ) ;
QxToolTip.prototype.setShowInterval = function() {};
function ImageIcon() {Widget.call(this) ;};
ImageIcon.extend( Widget , "ImageIcon" ) ;
function NLabel() {Widget.call(this) ;};
NLabel.extend( Widget , "NLabel" ) ;

function ConnectionTestButton( p ) {ActionButton.call( this , p ) ;}
ConnectionTestButton.extend( ActionButton , "ConnectionTestButton" ) ;
ConnectionTestButton.prototype.setLabel = function( lst ) {};

// EOF

// Helper

_tool.Config.createReadCSVSettingParams = function( stg , conf ) {
    var ret = [] ;
    var tmp = _tool.Wrench.createEncodingCombobox( stg , conf , true ) ;
    tmp.setEasyFlag( false ) ;
    ret.push( tmp );
    var tmp = _tool.Wrench.create( stg ,
                    { wedget : 'text' , label : 'label_record_startrow' , name : 'startrow' , width : 30 , value : '1' , required : true , validetetype : _tool.VALIDATE_NUMBER , configtype : conf , easy : false } ,
                    { wedget : 'combobox' , label : 'label_csv_separator' , name : 'separator' , width : 120 , configtype : conf , list : [
                            { name : ',' , value : ',' } ,
                            { name : '(tab)' , value : 'tab'} ,
                            { name : '(space)' , value : 'space' } ,
                            { name : ';' , value : ';'} ,
                            { name : '(none)' , value : 'none' } ] , easy : false } ,
                    { wedget : 'combobox' , label : 'label_csv_quoteby' , name : 'quoteby' , width : 120 , value : 'doublequote' , configtype : conf , list : [
                            { name : '(none)' , value : 'none' } ,
                            { name : '"' , value : 'doublequote' } ,
                            { name : "'" , value : 'singlequote' } ] , easy : false }
                ) ;
    for ( var cnt = 0 ; cnt < tmp.length ; cnt++ ) {
        ret.push( tmp[cnt] ) ;
    }
    return ret ;
};

_tool.Config.createReadCSVSettingConfig = function( stg , lbl , conf ) {
    var cfgtyp = (conf==null)?_tool.CONFIG_SETTING:conf;
    var lk = (lbl==null)?'label_csv_setting':lbl;
    var ret = new ActionGroupLayout( lk , stg , cfgtyp ) ;
    var itms = _tool.Config.createReadCSVSettingParams( stg , null ) ;
    for ( var cnt = 0 ; cnt < itms.length ; cnt++ ) {
        ret.addProperty( itms[cnt] ) ;
    }
    return ret ;
};

_tool.Config.createWriteCSVSettingParams = function( stg , conf ) {
    var ret = [] ;
    ret.push( _tool.Wrench.createEncodingCombobox( stg , conf , false ) );
    var tmp = _tool.Wrench.create( stg ,
                    { wedget : 'combobox' , label : 'label_csv_appendmode' , name : 'appendmode' , width : 120 , configtype : conf, list : [
                    		{ name : util.LiteralBundle.getLiteral('label_csv_appendmode_new') , value : 'new' } ,
                    		{ name : util.LiteralBundle.getLiteral('label_csv_appendmode_append') , value : 'append' } ,
                    		{ name : util.LiteralBundle.getLiteral('label_csv_appednmode_error') , value : 'error' } ] } ,
                    { wedget : 'combobox' , label : 'label_csv_separator' , name : 'separator' , width : 120 , configtype : conf , list : [
                            { name : ',' , value : ',' } ,
                            { name : '(tab)' , value : 'tab'} ,
                            { name : '(space)' , value : 'space' } ,
                            { name : ';' , value : ';'} ] } ,
                    { wedget : 'combobox' , label : 'label_csv_quoteby' , name : 'quoteby' , width : 120 , value : 'doublequote' , configtype : conf , list : [
                            { name : '(none)' , value : 'none' } ,
                            { name : '"' , value : 'doublequote' } ,
                            { name : "'" , value : 'singlequote' } ] } ,
                    { wedget : 'combobox' , label : 'label_csv_quotemode' , name : 'quotemode' , width : 120 , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_csv_quotemode_all') , value : 'all' } ,
                            { name : util.LiteralBundle.getLiteral('label_csv_quotemode_notnull') , value : 'notnull' } ] } ,
                    { wedget : 'combobox' , label : 'label_fixed_linefeed' , name : 'linefeed' , width : 120 , configtype : conf , list : [
                            { name : 'CR+LF' , value : 'CR+LF' } ,
                            { name : 'LF' , value : 'LF' } ,
                            { name : 'CR' , value : 'CR' } ] } ,
                    { wedget : 'combobox' , label : 'label_csv_writeheader' , name : 'header' , width : 120 , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_csv_writeheader_false') , value : 'false' } ,
                            { name : util.LiteralBundle.getLiteral('label_csv_writeheader_true') , value : 'true' } ] }
                ) ;
    for ( var cnt = 0 ; cnt < tmp.length ; cnt++ ) {
        ret.push( tmp[cnt] ) ;
    }
    return ret ;
};
_tool.Config.createWriteCSVSettingConfig = function( stg , lbl , conf , easy ) {
    var cfgtyp = (conf==null)?_tool.CONFIG_SETTING:conf;
    var lk = (lbl==null)?'label_csv_setting':lbl;
    var ret = new ActionGroupLayout( lk , stg , cfgtyp ) ;
    var beasy = (easy==null)?true:easy ;
    var itms = _tool.Config.createWriteCSVSettingParams( stg , null ) ;
    for ( var cnt = 0 ; cnt < itms.length ; cnt++ ) {
        itms[cnt].setEasyFlag( beasy ) ;
        ret.addProperty( itms[cnt] ) ;
    }
    return ret ;
};

_tool.MailHelper = new Object() ;

function MailOptionSelector(name , auth , cfgtyp) {
	var authmode = auth == null ? "false" : auth ;
	var param = { "name":name , "value":auth , "configtype":cfgtyp ,"list":[
	{"text" : util.LiteralBundle.getLiteral( "label_mail_certification_none" ) , "value" : "false" , "checked" : ("false" == authmode) } ,
	{ "text" : "POP Before SMTP" , "value" : "true", "checked" : ("true" == authmode) } ,
	{ "text" : util.LiteralBundle.getLiteral( "label_mail_certification_smtp" ) , "value" : "smtp", "checked" : ("smtp" == authmode) }
																	] } ;
	ActionRadioButton.call(this,param) ;
}
MailOptionSelector.extend( ActionRadioButton , "MailOptionSelector" ) ;

MailOptionSelector.MODE_NONE = 0 ;
MailOptionSelector.MODE_POP3_BEFORE = 1 ;
MailOptionSelector.MODE_SMTP_AUTH = 2 ;

MailOptionSelector.prototype.valueToAuthMode = function( val ) {
    var mod = -1 ;
    if ( val == "false" ) {
		mod = MailOptionSelector.MODE_NONE ;
    } else if ( val == "true" ) {
		mod = MailOptionSelector.MODE_POP3_BEFORE ;
    } else if ( val == "smtp" ) {
		mod = MailOptionSelector.MODE_SMTP_AUTH ;
    }
    return mod;
};

MailOptionSelector.prototype.loadVariable = function() {
	var value = ActionRadioButton.prototype.loadVariable.call(this) ;
	var md = this.valueToAuthMode( value?value["value"]: null ) ;
	var conf = this.getParent().getConfigType() ;
	var params = null ;
	// each Property
    if ( md == MailOptionSelector.MODE_POP3_BEFORE ) {
		params = _tool.Wrench.create( this.getParent().getStage() ,
        { wedget : "text" , label : "label_pop3server" , name : 'pop3server' , value : "" , required : true , configtype : conf } ,
        { wedget : "radio" , name : "popProtocol" , label : "label_use_pop_ssl" , configtype : conf , 
            value : "pops" , checked : false , text : util.LiteralBundle.getLiteral( 'label_do' ) ,
                     list : [ { text : util.LiteralBundle.getLiteral( 'label_dont' ) , value : "pop3" , checked : true } ] } ,
        { wedget : 'radio' , name : "popSslType" , label : "label_use_starttls" , configtype : conf ,
            value : "starttls" , checked : false , text : util.LiteralBundle.getLiteral( 'label_do' ) ,
                     list : [ { text : util.LiteralBundle.getLiteral( 'label_dont' ) , value : "default" , checked : true } ] } ,
	    { wedget : "text" , label : "label_pop3port" , name : 'pop3port' , value : "110" , configtype : conf } ,
	    { wedget : "text" , label : "label_user" , name : "user" , configtype : conf , required : true , validatetype : _tool.VALIDATE_ALPHA  } ,
	    { wedget : "password" , label : "label_password" , name : "password" , configtype : conf } ,
	    { wedget : "radio" , name : "auth" , label : "label_certification" , configtype : conf ,
	      value : "none" , checked : true , text : util.LiteralBundle.getLiteral( 'label_plantext' ) ,
	      list : [ { text : util.LiteralBundle.getLiteral( 'label_apop' ) , value : "APOP" , checked : false } ]  } ,
	    { wedget : "text" , label : "label_interval" , name : 'interval' , value : "" , required : true , configtype : conf }
	) ;
    } else if ( md == MailOptionSelector.MODE_SMTP_AUTH ) {
		params = _tool.Wrench.create( this.getParent().getStage() ,
	    { wedget : "text" , label : "label_user" , name : "user" , configtype : conf , required : true , validatetype : _tool.VALIDATE_ALPHA  } ,
	    { wedget : "password" , label : "label_password" , name : "password" , configtype : conf } ,
	    { wedget : "radio" , name : "smtpauth" , label : "label_certification" , configtype : conf ,
	      value : "plain" , checked : true , text : util.LiteralBundle.getLiteral( 'label_plantext' ) ,
	      list : [ { text : util.LiteralBundle.getLiteral( 'label_crommd5' ) , value : "cram-md5" , checked : false } ]  }
	) ;
    }

    if ( params ) {
		var parent = this.getParent().getParent() ;
		for ( var kk = 0 ; kk < params.length ; kk++ ) {
			parent.addProperty( params[kk] ) ;
		}
    }

};

_tool.MailHelper.createMailParams = function( stg , conf , typ ) {
    var ret ;
    if ( typ ) {
        ret = _tool.Wrench.create( stg ,
        { wedget : "text" , label : "label_host" , name : "host" , width : 200 , value : "" , configtype : conf , required : true , validatetype : _tool.VALIDATE_ALPHA } ,
        { wedget : "radio" , name : "protocol" , label : "label_use_pop_ssl" , configtype : conf , 
            value : "pops" , checked : false , text : util.LiteralBundle.getLiteral( 'label_do' ) ,
                     list : [ { text : util.LiteralBundle.getLiteral( 'label_dont' ) , value : "pop3" , checked : true } ] } ,
        { wedget : 'radio' , name : "sslType" , label : "label_use_starttls" , configtype : conf ,
            value : "starttls" , checked : false , text : util.LiteralBundle.getLiteral( 'label_do' ) ,
                     list : [ { text : util.LiteralBundle.getLiteral( 'label_dont' ) , value : "default" , checked : true } ] } ,
        { wedget : "text" , label : "label_port" , name : "port" , width : 80 , value : "110" ,configtype : conf , required : true , validatetype : _tool.VALIDATE_NUMBER } ,
        { wedget : "text" , label : "label_user" , name : "user" , width : 144 , configtype : conf , required : true , validatetype : _tool.VALIDATE_ALPHA  } ,
        { wedget : "password" , label : "label_password" , name : "password" , width : 144 , configtype : conf } ,
        { wedget : "radio" , name : "auth" , label : "label_certification" , configtype : conf ,
            value : "none" , checked : true , text : util.LiteralBundle.getLiteral( 'label_plantext' ) ,
                     list : [ { text : util.LiteralBundle.getLiteral( 'label_apop' ) , value : "APOP" , checked : false } ]  } ,
		{ wedget : "text" , label : "label_timeout" , name : "timeout" , value : "60" , configtype : conf, required : true , validatetype : _tool.VALIDATE_NUMBER } ,
		{ wedget : "checkbox" , label : "label_onlyonemail" , name : "onlyonemail" , checked : false , configtype : conf } ,
		{ wedget : "radio" , name : "bodytype" , label : "label_htmlmail" , configtype : conf , easy : false ,
            value : "TEXT" , checked : true , text : util.LiteralBundle.getLiteral( 'label_text_body' ) ,
                     list : [ { text : util.LiteralBundle.getLiteral( 'label_html_body' ) , value : "HTML" , checked : false } ]  }
        ) ;

		//ret[0].addProperty( new ConnectionTestButton( "POP3" ) ) ;

    } else {
        tmp = _tool.Wrench.create( stg ,
        { wedget : "text" , label : "label_host" , name : "host" , width : 200 , value : "" , configtype : conf , required : true , validatetype : _tool.VALIDATE_ALPHA } ,
        { wedget : "radio" , name : "protocol" , label : "label_use_smtp_ssl" , configtype : conf , 
            value : "smtps" , checked : false , text : util.LiteralBundle.getLiteral( 'label_do' ) ,
                     list : [ { text : util.LiteralBundle.getLiteral( 'label_dont' ) , value : "smtp" , checked : true } ] } ,
        { wedget : 'radio' , name : "sslType" , label : "label_use_starttls" , configtype : conf ,
            value : "starttls" , checked : false , text : util.LiteralBundle.getLiteral( 'label_do' ) ,
                     list : [ { text : util.LiteralBundle.getLiteral( 'label_dont' ) , value : "default" , checked : true } ] } ,
        { wedget : "text" , label : "label_port" , name : "port" , width : 80 , value : "25" ,configtype : conf , required : true , validatetype : _tool.VALIDATE_NUMBER } ,
        { wedget : "text" , label : "label_timeout" , name : "timeout" , width : 144 , value : "60" , configtype : conf, required : true , validatetype : _tool.VALIDATE_NUMBER }
        ) ;
        ret = [] ;
		for ( var cnt = 0 ; cnt < tmp.length ; cnt++ ) {
			ret.push( tmp[cnt] ) ;
		} ;

		var opt = new MailOptionSelector( "certification" , null , (conf==null)?_tool.CONFIG_CONNECTION:conf ) ;
		ret.push( _tool.Wrench.createBaseText( stg , "label_certification" , (conf==null)?_tool.CONFIG_CONNECTION:conf , opt ) ) ;

		//ret[0].addProperty( new ConnectionTestButton( "SMTP" ) ) ;

    }
    return ret ;
}

_tool.MailHelper.createMailConfig = function( stg , conf , lbl  , typ ) {
    var ret = new ActionGroupLayout( ((lbl==null)?'label_mail_connection':lbl) , stg , (conf==null)?_tool.CONFIG_CONNECTION:conf ) ;
    var tmp = _tool.MailHelper.createMailParams( stg , null , typ ) ;
    for ( var cnt = 0 ; cnt < tmp.length ; cnt++ ) {
        ret.addProperty( tmp[cnt] ) ;
    }
    return ret ;
}

_tool.ScheduleHelper = new Object() ;

function TimeSelector( param ) {
	ActionControl.call( this , param ) ;
	var cnt , txt ;
	var hhParam = { "value":"12" } ;
	var lst = [] ;
	for ( cnt = 0 ; cnt < 24 ; cnt++ ) {
		if ( cnt < 10 ) {
			txt = "0" + cnt ;
		} else {
			txt = "" + cnt ;
		}
		lst.push( { "name":txt , "value":txt } ) ;
	}
	hhParam["list"] = lst ;
	var hh = new ActionComboBox( hhParam ) ;
	var lbl = new ActionLabel( ":" ) ;
	hhParam = { "value":"00" } ;
	lst = [] ;
	for ( cnt = 0 ; cnt < 60 ; cnt++ ) {
		if ( cnt < 10 ) {
			txt = "0" + cnt ;
		} else {
			txt = "" + cnt ;
		}
		lst.push( { "name":txt , "value":txt } ) ;
	}
	var mm = new ActionComboBox( hhParam ) ;
	this.add( hh ) ; this.add( lbl ) ; this.add( mm ) ;
	this.setUserData( "DEFAULTVALUE" , param.value == null? "12:00":param.value ) ;
}

TimeSelector.extend( ActionControl , "TimeSelector" ) ;

TimeSelector.prototype.loadVariable = function() {
	var value = ActionControl.prototype.loadVariable.call( this ) ;
	if ( ! value ) {
		return ;
	} else {
		value = value["value"] ;
	}
	if ( value == null || value.length == 0 ) {
		value = this.getUserData("DEFAULTVALUE") ;
	}
	var tt = value.split(":");
	var ch = this.getChildren() ;
	ch[0].setValue( tt[0] ) ;
	ch[2].setValue( tt[1] ) ;
};

function ScheduleDayCheckbox( param ) {
	ActionText.call( this , param ) ;
};
ScheduleDayCheckbox.extend( ActionText , "ScheduleDayCheckbox" ) ;
ScheduleDayCheckbox.prototype.getScheduleDays = function( v ) {
	var days = "" ;
	var vals = v.split( "," ) ;
	for ( var dd = 0 ; dd < vals.length ; dd++ ) {
		if ( days.length > 0 ) { days += " , " ; }
		if ( "endday" == vals[dd] ) {
			days += util.LiteralBundle.getLiteral( "label_schedule_monthend" ) ;
		} else {
			days += vals[dd] ;
		}
	}
	return days ;
};
ScheduleDayCheckbox.prototype.loadVariable = function() {
	var value = ActionControl.prototype.loadVariable.call( this ) ;
	if ( ! value ) {
		return ;
	} else {
		value = value["value"] ;
	}
	if ( value == null || value.length == 0 ) {
		value = "" ;
	}
	this.setValue( this.getScheduleDays( value ) ) ;
};

function ScheduleTypeComboBox( param , d , s ) {
	ActionComboBox.call( this, param ) ;
	this._days = d ;
	this._sched = s ;
};
ScheduleTypeComboBox.extend( ActionComboBox , "ScheduleTypeComboBox") ;
ScheduleTypeComboBox.prototype.loadVariable = function() {
	var val = ActionComboBox.prototype.loadVariable.call( this ) ;
	var typ = val["value"];
	if ( "interval" == typ ) {
		this.showDays(false,typ) ;
		this.showInterval(true) ;
	} else if ( "week" == typ ) {
		this.showDays(true,typ) ;
		this.showInterval(false) ;
	} else if ( "monthly" == typ ) {
		this.showDays( true,typ ) ;
		this.showInterval( false ) ;
	}
	return val ;
};

ScheduleTypeComboBox.prototype.showDays = function( flg , typ ) {
    for ( var cnt = 0 ; cnt < this._days.length ; cnt++ ) {
		this._days[cnt].setVisible( flg ) ;
    }
	if ( typ == "monthly" && flg ) {
		this._days[2].setVisible(true) ;
	} else {
		this._days[2].setVisible(false) ;
	}
	if ( typ == "week" && flg ) {
		this._days[0].setVisible(true) ;
	} else {
		this._days[0].setVisible(false) ;
	}
};

ScheduleTypeComboBox.prototype.showInterval = function( flg ) {
    for ( var cnt = 0 ; cnt < this._sched.length ; cnt++ ) {
		this._sched[cnt].setVisible(flg) ;
	}
};


_tool.ScheduleHelper.createScheduleParams = function( stg , conf, dval ) {
    var ret = new Array() ;
    var cnt ;
    var conftyp = (conf==null)?null:_tool.CONFIG_SCHEDULE ;

    var defaultvalue = { intervaltime : '0' , unittype : "3" , time : '12:00' } ;
    if ( dval ) {
        defaultvalue = dval ;
    }

    // Days
    var days = _tool.Wrench.create( stg ,
                { wedget : 'checkbox' ,name : "monday" , value : null , label : "label_schedule_run_day" , text : util.LiteralBundle.getLiteral( 'label_monday_short' ), configtype : conftyp } ) ;
    var itms = _tool.Wrench.createCheckBoxItem( stg ,
                { name : "tuesday" , value : null , text : util.LiteralBundle.getLiteral( 'label_tuesday_short' ), configtype : conftyp } ,
                { name : "wednesday" , value : null , text : util.LiteralBundle.getLiteral( 'label_wednesday_short' ), configtype : conftyp } ,
                { name : "thursday" , value : null , text : util.LiteralBundle.getLiteral( 'label_thursday_short' ), configtype : conftyp } ,
                { name : "friday" , value : null , text : util.LiteralBundle.getLiteral( 'label_friday_short' ), configtype : conftyp } ,
                { name : "saturday" , value : null , text : util.LiteralBundle.getLiteral( 'label_saturday_short' ), configtype : conftyp }  ,
                { name : "sunday" , value : null , text : util.LiteralBundle.getLiteral( 'label_sunday_short' ), configtype : conftyp } ) ;
    for ( cnt = 0 ; cnt < itms.length ; cnt++ ) {
        days[0].addProperty( itms[ cnt ] ) ;
    }
	var lbl = _tool.Wrench.createBaseText( stg , "label_schedule_run_time" , conftyp , new TimeSelector( { "name":"time","value": defaultvalue['time'] } ) ) ;
    days.push( lbl ) ;
	lbl =  _tool.Wrench.createBaseText( stg , 'label_schedule_execday' , conf , new ScheduleDayCheckbox( { "name":"monthlyday" , "value":"" }) ) ;
	days.push( lbl ) ;

    // Interval
    var interval = _tool.Wrench.create( stg ,
                { wedget : 'text' , name : "intervaltime" , value : defaultvalue['intervaltime'] , label : "label_intervaltype" , text : "10" , width : 50, configtype : conftyp , required : true , validatetype : _tool.VALIDATE_NUMBER } ,
                { wedget : 'checkbox' , name : "execfirst" , checked : false , label : "label_interval_exec_first" , text : "" , configtype : conftyp }
                 ) ;
    var unit = new ActionComboBox( { "name":"unittype" , "value":"3" , "list":[
	{ "name": util.LiteralBundle.getLiteral('label_interval_sec') , "value": "1" } ,
	{ "name": util.LiteralBundle.getLiteral('label_interval_min') , "value": "2" } ,
	{ "name": util.LiteralBundle.getLiteral('label_interval_hour') , "value": "3" } ] } ) ;
    interval[0].addProperty( unit ) ;

    var sht = new ScheduleTypeComboBox( { "name" : "scheduletype" , "value":"interval" , "list":[
	{ "name":util.LiteralBundle.getLiteral( 'label_schedule_interval' ) , "value":"interval" } ,
	{ "name":util.LiteralBundle.getLiteral( 'label_schedule_day' ) , "value":"week" } ,
	{ "name":util.LiteralBundle.getLiteral( 'label_schedule_monthly' ) , "value":"monthly" }
			] } , days , interval ) ;
	lbl = _tool.Wrench.createBaseText( stg , "label_schedule_type" , conftyp , sht ) ;

    var period = _tool.Wrench.createBaseText( stg , "label_schedule_period" , conftyp , new TimeSelector( {"value":"00:00" , "name":"validstarttime"} ) ) ;
    period.addProperty( new ActionLabel( util.LiteralBundle.getLiteral( "label_fromto" ) ) ) ;
    period.addProperty( new TimeSelector( { "name":"validendtime" , "value": "23:59"} ) ) ;
    interval.push( period ) ;

    ret.push( lbl ) ;
    ret.push( days[0] ) ;
    ret.push( days[1] ) ;
    ret.push( interval[0] ) ;
    ret.push( period ) ;
    ret.push( interval[1] ) ;
	ret.push( days[2] ) ;
    return ret ;
}

_tool.ScheduleHelper.createScheduleConfig = function( stg , dval ) {
    var ret = new ActionGroupLayout( 'label_schedule_conf' , stg , _tool.CONFIG_SCHEDULE ) ;
    var flds = _tool.ScheduleHelper.createScheduleParams( stg , dval ) ;
    for ( var cnt = 0 ; cnt<flds.length ; cnt++ ) {
        ret.addProperty( flds[ cnt ] ) ;
    }
    return ret ;
}

// RDB Helper

_tool.Config.getRDBPropsDef = function( dbtype , conftyp ) {
    if ( dbtype == _tool.RDB_TYPE_INTERNALDB ) {
        return [] ;
    }
    var def = [
                { wedget : "text" , name : "rdb_driver" , label : "label_db_driver" , width : 280 , configtype : conftyp , required : true } ,
                { wedget : "text" , name : "rdb_url" , label : "label_url" ,  width : 420 , configtype : conftyp , required : true } ,
                { wedget : "text" , name : "rdb_username" , label : "label_user" ,  width : 120 , configtype : conftyp , required : true } ,
                { wedget : "password" , name : "rdb_password" , label : "label_password" , value : "" , width : 120 , configtype : conftyp } ,
                { wedget : "radio" , name : "rdb_pool" , label : "label_db_connectionpool" , configtype : conftyp ,
                    value : "true" , checked : true , text : "TRUE" ,
                     list : [ { text : "FALSE" , value : "false" , checked : false } ] } ];

    return def ;
}

function RDBComboBox( nm , lang , dbtyp ) {
	var vParam = { "name":(nm==null)?'rdbtype':nm, } ;
	var l = (lang==null)?true:lang ;
	var lst = [] ;
	var rdbtyp = this._rdbtypes = RDBComboBox.getDBTypeList( l , dbtyp ) ;
	for ( var cnt = 0 ; cnt < rdbtyp.length ; cnt++ ) {
		lst.push( { "name":rdbtyp[cnt].name , "value": rdbtyp[cnt].name } ) ;
	}
	vParam["list"] = lst ;
	ActionComboBox.call( this , vParam ) ;
}

RDBComboBox.extend( ActionComboBox , "RDBComboBox" ) ;

RDBComboBox.getDBTypeList = function( lang , type ) {
	var rdbtypes ;
	if ( lang ) {
		rdbtypes = [
				{ name : "Default DB" ,	driver : "org.hsqldb.jdbcDriver" , uri : "jdbc:hsqldb:mem:aname" , isdefault : "true" , dbtype : _tool.RDB_TYPE_INTERNALDB } ,
				{ name : "Oracle(Thin)" ,  driver : "oracle.jdbc.OracleDriver" , uri : "jdbc:oracle:thin:@[HostName]:[Port]:[ORACLE_SID]" , dbtype : _tool.RDB_TYPE_ORACLE } ,
				{ name : "Oracle(OCI)" ,   driver : "oracle.jdbc.OracleDriver" , uri : "jdbc:oracle:oci8:@[ServiceName]" , dbtype : _tool.RDB_TYPE_ORACLE } ,
				{ name : "DB2(type4)" , driver : "com.ibm.db2.jcc.DB2Driver" , uri : "jdbc:db2://[HostName]:[Port]/[DataBaseName]" , dbtype : _tool.RDB_TYPE_DB2 } ,
				{ name : "DB2(type2)" , driver : "com.ibm.db2.jcc.DB2Driver" , uri : "jdbc:db2:[DataBaseName]" , dbtype : _tool.RDB_TYPE_DB2 } ,
				{ name : "SQLServer(JDBC)" ,   driver : "com.microsoft.jdbc.sqlserver.SQLServerDriver" , uri : "jdbc:microsoft:sqlserver://[HostName]:[Port];SELECTMETHOD=cursor" , dbtype : _tool.RDB_TYPE_SQLSERVER } ,
				{ name : "SQLServer2005+(JDBC)" ,   driver : "com.microsoft.sqlserver.jdbc.SQLServerDriver" , uri : "jdbc:sqlserver://[HostName]:[Port];SELECTMETHOD=cursor" , dbtype : _tool.RDB_TYPE_SQLSERVER } ,
				{ name : "MySQL" ,	driver : "org.gjt.mm.mysql.Driver" , uri : "jdbc:mysql://[HostName]:[Port]/[DataBaseName]" , dbtype : _tool.RDB_TYPE_MYSQL } ,
				{ name : "PostgreSQL" ,	driver : "org.postgresql.Driver" , uri : "jdbc:postgresql://[HostName]:[Port]/[DataBaseName]" , dbtype : _tool.RDB_TYPE_POSTGRES } ,
				{ name : "DB2(iSeries)" ,  driver : "com.ibm.as400.access.AS400JDBCDriver" , uri : "jdbc:as400://[HostName]/[LibraryName]" , dbtype : _tool.RDB_TYPE_ISERIES } ,
				{ name : "Access" ,  driver : "sun.jdbc.odbc.JdbcOdbcDriver" , uri : "jdbc:odbc:[OdbcName]" , dbtype : _tool.RDB_TYPE_ODBC }
			] ;
	}

	if ( type != _tool.RDB_TYPE_ALL ) {
		var ret = [] ;
		for ( var cnt = 0 ; cnt < rdbtypes.length ; cnt++ ) {
			if ( rdbtypes[cnt].dbtype == type ) {
				ret.push( rdbtypes[cnt] ) ;
			}
		}
		return ret ;
	}
	return rdbtypes ;
}

_tool.Config.createRDBConnectionParams = function( stg , lang , conftyp , dbtyp, tnamereq , ignoreUser ) {
    var ret = [] ;
    var dbtype = (dbtyp==null)?_tool.RDB_TYPE_ALL:dbtyp;
    var tnreq = (tnamereq==null)?true:tnamereq;

    if ( dbtype != _tool.RDB_TYPE_INTERNALDB ) {
        var rdbcombo = new RDBComboBox( 'rdb_type' , lang , dbtype ) ;
		var typ = _tool.Wrench.createBaseText( stg , 'label_db_type' , conftyp, rdbcombo ) ;
        typ.addProperty( rdbcombo ) ;
        var itms = _tool.Wrench.create( stg ,
                    { wedget : "text" , name : "rdb_driver" , label : "label_db_driver" , width : 280 , configtype : conftyp , required : true } ,
                    { wedget : "text" , name : "rdb_url" , label : "label_url" ,  width : 420 , configtype : conftyp , required : true } ,
					{ wedget : "text" , name : "rdb_username" , label : "label_user" ,  width : 120 , configtype : conftyp , required : ignoreUser ? false : true } ,
                    { wedget : "password" , name : "rdb_password" , label : "label_password" , value : "" , width : 120 , configtype : conftyp } ,
					{ wedget : "text" , name : "useSchemata" , label : "label_rdb_use_schemata" ,  width : 120 , configtype : conftyp , required : false } ,
                    { wedget : "radio" , name : "rdb_pool" , label : "label_db_connectionpool" , configtype : conftyp ,
                        value : "true" , checked : true , text : "TRUE" ,
                         list : [ { text : "FALSE" , value : "false" , checked : false } ]  }
                    ) ;
        ret.push( typ ) ;
        for ( var cnt = 0 ; cnt < itms.length ; cnt++ ) {
            ret.push( itms[cnt] ) ;
        }

        //ret[0].addProperty( new ConnectionTestButton( "RDB" ) ) ;
    }
    var text = _tool.Wrench.create( stg, { wedget : 'text' , name : "table_name" , value : "" , label : "label_tablename" , width : 200 , configtype : conftyp , required : tnreq } )[0];
    ret.push(text);
    return ret ;
}

_tool.Config.createRDBConnectionConfig = function( stg , conf , lbl , dbtype , lang , tnamereq , ignoreUser ) {
    var cfgtyp = (conf==null)?_tool.CONFIG_CONNECTION:conf;
    var lk = (lbl==null)?'label_connection':lbl;
    var ret = new ActionGroupLayout( lk , stg , cfgtyp ) ;
    var itms = _tool.Config.createRDBConnectionParams( stg , lang , cfgtyp , dbtype, tnamereq , ignoreUser ) ;
    for ( var cnt = 0 ; cnt < itms.length ; cnt++ ) {
        ret.addProperty( itms[cnt] ) ;
    }
    return ret ;
}

_tool.Config.setupRDBHiddenProperties = function( targ , cfgtyp , dbtype ) {
	/*
    if ( dbtype == _tool.RDB_TYPE_INTERNALDB ) {
        _tool.ActionPackHelper.setProprtyValue( targ.getStageType() , targ.getActionOrder() , cfgtyp , 'rdb_type' , 'Default DB', null ) ;
        _tool.ActionPackHelper.setProprtyValue( targ.getStageType() , targ.getActionOrder() , cfgtyp , 'rdb_driver' , 'org.hsqldb.jdbcDriver', null ) ;
        _tool.ActionPackHelper.setProprtyValue( targ.getStageType() , targ.getActionOrder() , cfgtyp , 'rdb_url' , 'jdbc:hsqldb:mem:aname', null ) ;
        _tool.ActionPackHelper.setProprtyValue( targ.getStageType() , targ.getActionOrder() , cfgtyp , 'rdb_username' , '', null ) ;
        _tool.ActionPackHelper.setProprtyValue( targ.getStageType() , targ.getActionOrder() , cfgtyp , 'rdb_password' , '', null ) ;
        _tool.ActionPackHelper.setProprtyValue( targ.getStageType() , targ.getActionOrder() , cfgtyp , 'rdb_pool' , true, null ) ;
        _tool.ActionPackHelper.setProprtyValue( targ.getStageType() , targ.getActionOrder() , cfgtyp , 'use_default' , true, null ) ;
    }
	*/
}

function PipelineListButton() {ActionButton.call( this , {"name":"PlBtn","widget":"button"} ) ;}
PipelineListButton.extend( ActionButton , "PipelineListButton" ) ;
PipelineListButton.prototype.setLabel = function( lst ) {lst.add( this.getValue() );};

/*
 ************************************************************************
 * FixedLengthHelper
 ************************************************************************
 */


_tool.Config.createReadFixedLengthSettingParams = function( stg , conf ) {
    var ret = [] ;
    var tmp = _tool.Wrench.createEncodingCombobox( stg , conf , true ) ;
    tmp.setEasyFlag( true ) ;
    ret.push( tmp );
    var tmp = _tool.Wrench.create( stg ,
                    { wedget : 'text' , label : 'label_record_startrow' , name : 'startrow' , width : 240 , value : '1' , required : false , validetetype : _tool.VALIDATE_NUMBER , configtype : conf , easy : false } ,
                    { wedget : 'combobox' , label : 'label_fixed_delimiter' , name : 'delimiter' , width : 240 , value : '2' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_recordlength') , value : '2' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_linefeed') , value : '1' } ] , easy : false } ,
                    { wedget : 'text' , label : 'label_fixed_recordlength' , name : 'recordlength' , width : 240 , value : '256' , validetetype : _tool.VALIDATE_NUMBER , configtype : conf , easy : true } ,
                    { wedget : 'combobox' , label : 'label_fixed_packedsign' , name : 'packedsign' , width : 240 , value : '1' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_required') , value : '0' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_option') , value : '1' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_any') , value : '2' } ] , easy : false } ,
                    { wedget : 'combobox' , label : 'label_fixed_packedsignformat' , name : 'packedsignformat' , width : 240 , value : '0' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_c_d') , value : '0' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_acef_bd') , value : '1' } ] , easy : false } ,
                    { wedget : 'combobox' , label : 'label_fixed_zonesign' , name : 'zonesign' , width : 240 , value : '1' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_required') , value : '0' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_option') , value : '1' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_any') , value : '2' } ] , easy : false } ,
                    { wedget : 'combobox' , label : 'label_fixed_zonesignformat' , name : 'zonesignformat' , width : 240 , value : '0' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_c_d') , value : '0' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_ebcdic') , value : '1' } ] , easy : false }
                ) ;
    for ( var cnt = 0 ; cnt < tmp.length ; cnt++ ) {
        ret.push( tmp[cnt] ) ;
    }
    return ret ;
}


_tool.Config.createReadFixedLengthSettingConfig = function( stg , lbl , conf ) {
    var cfgtyp = (conf==null)?_tool.CONFIG_SETTING:conf;
    var lk = (lbl==null)?'label_fixedlength':lbl;
    var ret = new ActionGroupLayout( lk , stg , cfgtyp ) ;
    var itms = _tool.Config.createReadFixedLengthSettingParams( stg , null ) ;
    for ( var cnt = 0 ; cnt < itms.length ; cnt++ ) {
        ret.addProperty( itms[cnt] ) ;
    }
    return ret ;
}


_tool.Config.createWriteFixedLengthSettingParams = function( stg , conf ) {
    var ret = [] ;
    ret.push( _tool.Wrench.createEncodingCombobox( stg , conf , false ) );
    var tmp = _tool.Wrench.create( stg ,
                    { wedget : 'combobox' , label : 'label_fixed_delimiter' , name : 'delimiter' , width : 240 , value : '2' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_recordlength') , value : '2' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_linefeed') , value : '1' } ] , easy : false } ,
                    { wedget : 'text' , label : 'label_fixed_recordlength' , name : 'recordlength' , width : 240 , value : '256' , validetetype : _tool.VALIDATE_NUMBER , configtype : conf , easy : true } ,
                    { wedget : 'combobox' , label : 'label_fixed_linefeed' , name : 'linefeed' , width : 240 , configtype : conf , list : [
                            { name : 'CR+LF' , value : 'CR+LF' } ,
                            { name : 'LF' , value : 'LF' } ,
                            { name : 'CR' , value : 'CR' } ] , easy : false } ,
                    { wedget : 'combobox' , label : 'label_fixed_packedsign' , name : 'packedsign' , width : 240 , value : '1' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_required') , value : '0' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_option') , value : '1' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_any') , value : '2' } ] , easy : false } ,
                    { wedget : 'combobox' , label : 'label_fixed_packedsignformat' , name : 'packedsignformat' , width : 240 , value : '0' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_c_d') , value : '0' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_packed_sign_acef_bd') , value : '1' } ] , easy : false } ,
                    { wedget : 'combobox' , label : 'label_fixed_zonesign' , name : 'zonesign' , width : 240 , value : '1' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_required') , value : '0' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_option') , value : '1' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_any') , value : '2' } ] , easy : false } ,
                    { wedget : 'combobox' , label : 'label_fixed_zonesignformat' , name : 'zonesignformat' , width : 240 , value : '0' , configtype : conf , list : [
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_c_d') , value : '0' } ,
                            { name : util.LiteralBundle.getLiteral('label_fixed_zoned_sign_ebcdic') , value : '1' } ] , easy : false }
                ) ;
    for ( var cnt = 0 ; cnt < tmp.length ; cnt++ ) {
        ret.push( tmp[cnt] ) ;
    }
    return ret ;
}

_tool.Config.createWriteFixedLengthSettingConfig = function( stg , lbl , conf ) {
    var cfgtyp = (conf==null)?_tool.CONFIG_SETTING:conf;
    var lk = (lbl==null)?'label_fixedlength':lbl;
    var ret = new ActionGroupLayout( lk , stg , cfgtyp ) ;
    var itms = _tool.Config.createWriteFixedLengthSettingParams( stg , null ) ;
    for ( var cnt = 0 ; cnt < itms.length ; cnt++ ) {
        ret.addProperty( itms[cnt] ) ;
    }
    return ret ;
}

// EOF
/*
 * net
 */

/*
 * XMLHttpRequest
 */
function createXMLHttpRequest() {

    var vObject = null ;

    if ( window.ActiveXObject ) {

        var vServers = [ "MSXML2.XMLHTTP.6.0", "MSXML2.XMLHTTP.5.0", "MSXML2.XMLHTTP.4.0", "MSXML2.XMLHTTP.3.0", "MSXML2.XMLHTTP.2.0", "MSXML2.XMLHTTP", "Microsoft.XMLHTTP" ] ;

        for ( var ii = 0 ; ii < vServers.length ; ii++ ) {
            try {
                vObject = new ActiveXObject( vServers[ ii ] ) ;
            } catch ( ex ) {
                vObject = null ;
            }
        }
        if ( vObject ) {
            return vObject ;
        }

    }

    if ( window.XMLHttpRequest ) {
        vObject = new XMLHttpRequest() ;
        vObject.overrideMimeType( 'text/xml' ) ;
        return vObject;
    }

    return null ;
}

var net = new Object() ;
net.READY_STATE_UNINITIALIZED = 0 ;
net.READY_STATE_LOADING       = 1 ;
net.READY_STATE_LOADED        = 2 ;
net.READY_STATE_INTERACTIVE   = 3 ;
net.READY_STATE_COMPLETE      = 4 ;

net.DEFAULT_CONTENT_TYPE      = "application/x-www-form-urlencoded; charset=UTF-8" ;
net.DEFAULT_HOST_NAME         = "" ;

net.ERROR_CODE = "error" ;
net.LOGINERROR_CODE = "login_error" ;

net.Parser = new Object() ;
net.Parser.ELEMENT_NODE       = 1 ;
net.Parser.ATTRIBUTE_NODE     = 2 ;
net.Parser.TEXT_NODE          = 3 ;
net.Parser.CDATA_SECTION_NODE = 4 ;
net.Parser.ENTITY_REFERENCE_NODE = 5 ;
net.Parser.ENTITY_NODE        = 6 ;
net.Parser.PROCESSING_INSTRUCTION_NODE = 7 ;
net.Parser.COMMENT_NODE       = 8 ;
net.Parser.DOCUMENT_NODE      = 9 ;
net.Parser.DOUCMENT_TYPE_NODE = 10 ;
net.Parser.DOCUMENT_FRAFMENT_NODE = 11 ;
net.Parser.NOTACTION_NODE     = 12 ;
net.Parser.TEXT_NODE_NAME     = "Text" ;
net.Parser.CDATA_NODE_NAME    = "CDATA" ;

net.Parser.PARSER_TYPE_NONE = 0 ;
net.Parser.PARSER_TYPE_JSON = 10 ;
net.Parser.PARSER_TYPE_LOG  = 20 ;

net.helpLink = false ;
net.HELP = function() {
	if ( ! net.helpLink ) {
		net.helpLinkCheck(net.openHelpPage) ;
	} else {
		net.openHelpPage();
	}
};
net.helpLinkCheck = function(openFunc) {
	var url = "/mc/urlconnect.mc" ;
	var param = "url=" + __HELP_PAGE_URL + "&timeout=3000"
	new Ajax.Request( url, {method: 'get', parameters: param,
				onSuccess: function(req,json) {
				net.helpLink = true ;
				var dat ;
				eval( "dat = " + req.responseText + ";" ) ;
				if ( dat["connect"] == "false" ) {
					__HELP_PAGE_URL = __HELP_LOCAL_URL;
				}
				openFunc() ;
			}}) ;
};
net.openHelpPage= function() {
	window.open( __HELP_PAGE_URL , '_blank' );
};
net.openActionHelpWindow = function(id) {
	if ( ! net.helpLink ) {
		net.helpLinkCheck(new function() {window.open(GETHELPAGEURLSTRING(id), '_blank');}) ;
	} else {
		window.open( GETHELPAGEURLSTRING(id) , '_blank' ) ;
	}
};/*
 ************************************************************************
 *  BaseTransporter
 ************************************************************************
 */


/*
 ************************************************************************
 * Service Config
 ************************************************************************
 */
var WebServiceConfig = {
	host : [
		{ name : "" , port : "" , isdefault : true ,
		  service : [
			{ login : "/mc/login.mc" } ,
			{ logout : "/mc/logout.mc" } ,
			{ uiinfo : "/mc/uiinfo.mc" } ,

			{ tasklist : "/mc/designer/pipelinelist.mc" } ,
			{ taskinit : "/mc/designer/pipelinecreate.mc" } ,
			{ tasksave : "/mc/designer/pipelinesave.mc" } ,
			{ taskload : "/mc/designer/pipelineload.mc" } ,
			{ taskremove : "/mc/designer/pipelineremove.mc" } ,
			{ tasktest : "/mc/designer/pipelinetest.mc" } ,
			{ changerunmode : "/mc/designer/changerunmode.mc" } ,
			{ connecttest : "/mc/designer/connectiontest.mc" } ,

			{ fileupload : "/mc/designer/fileupload.mc" } ,
			{ fileread : "/mc/designer/fileread.mc" } ,
			{ getactionlist : "/mc/designer/actionlist.mc" } ,
			{ getimagemap : "/data/imagesmap.xml" } ,

			{ getliteralsja : "/mc/staticfile.mc?file=literal" } ,
			{ actionliteralja : "/mc/staticfile.mc?file=actionliteral" } ,

			{ taskrunmode : "/mc/designer/runmode.mc" } ,
			{ systemuser : "/mc/configuration/user/system.mc" } ,
			{ systeminfo : "/mc/configuration/info/systeminfo.mc" } ,
			{ systemconfig : "/mc/configuration/common/systemconfig.mc" } ,
			{ systemmaintenance : "/mc/configuration/common/logsettingconfig.mc" } ,
			{ processconfig : "/mc/configuration/process/config.mc" } ,
			{ httptriggerconfig : "/mc/configuration/httptrigger/config.mc" } ,
			{ ftpuser : "/mc/configuration/user/ftp.mc" } ,
			{ ftpservice : "/mc/configuration/user/ftpservice.mc" } ,
			{ sysconnecttest : "/mc/configuration/common/syscontest.mc" } ,
			{ historychart : "/mc/maintenance/monitor/historygraph.mc" } ,
			{ uiconfig : "/mc/configuration/process/uisettings.mc" } ,
			{ webapiconfig : "/mc/configuration/process/webapisettings.mc" } ,

			{ getlogfilename : "/mc/maintenance/log/getfilename.mc" } ,
			{ loadsyslog : "/mc/maintenance/log/systemlog.mc" }  ,
			{ snapshot : "/mc/maintenance/monitor/snapshot.mc" } ,
			{ sysmonitor : "/mc/maintenance/monitor/systemmonitor.mc" } ,

			{ tasksummary : "/mc/maintenance/monitor/pipelinesummary.mc" } ,
			{ tasksummarylog : "/mc/maintenance/monitor/pipelinesummarylog.mc" } ,
			{ requestsummary : "/mc/maintenance/monitor/requestsummary.mc" } ,
			{ requestrecover : "/mc/maintenance/monitor/recover.mc" } ,
			{ argumentconfig : "/mc/configuration/process/argumentconfig.mc" } ,

			{ exportpipeline : "/mc/designer/exportpipeline.mc" } ,
			{ importpipeline : "/mc/designer/importpipeline.mc" } ,
			{ downloadpipeline : "/mc/designer/downloadarchive.mc" } ,

			{ recordtemplate : "/mc/designer/recordtemplate.mc" } ,
			{ fileupload : "/mc/designer/fileupload.mc" } ,

			{ rdbtablelist : "/mc/designer/rdbtablelist.mc" } ,
			{ rdbfieldlist : "/mc/designer/rdbfieldlist.mc" } ,

			{ wsdlparse : "/mc/designer/wsdlparse.mc" } ,

			{ onsheetbooklist : "/mc/designer/onsheetbooklist.mc" } ,
			{ onsheetsheetlist : "/mc/designer/onsheetsheetlist.mc" } ,
			{ connectionpool : "/mc/configuration/connection/connectionpool.mc" } ,
			{ proxyconfig : "/mc/configuration/connection/proxy.mc" } ,
			{ mjslinkviewlist : "/mc/designer/mjslinkviewlist.mc" } ,
			{ mjslinkfieldlist : "/mc/designer/mjslinkfieldlist.mc" } ,
			{ sforcedescribeglobal : "/mc/designer/sforcedescribeglobal.mc" } ,
			{ sforcedescribesobject : "/mc/designer/sforcedescribesobject.mc" } ,
			{ sforceconnection : "/mc/designer/sforceconnection.mc" } ,
			{ shanonobjectlist : "/mc/designer/shanonobjectlist.mc" } ,
			{ shanonfieldlist : "/mc/designer/shanonfieldlist.mc" } ,
			{ shanonconnection : "/mc/designer/shanonconnection.mc" } ,

			{ license : "/mc/configuration/license/confirm.mc" }

		  ]
		}
	]
}

BaseTransporter = function() {
	this._servicemap = WebServiceConfig ;
	this._command = null ;
	this._multicommands = null ;
	this._repeater = null ;
	this._wait = false ;
}


BaseTransporter.prototype = {

	onReadyState : function() {
		var req = this._req ;
		var ready = req.readyState ;
		switch ( ready ) {
			case net.READY_STATE_LOADING :
				this.onLoading() ;
			break ;
			case net.READY_STATE_LOADED :
				this.onLoaded() ;
			break ;
			case net.READY_STATE_INTERACTIVE :
				this.onInterActive() ;
			break ;
			case net.READY_STATE_COMPLETE :
				this.onCompleted() ;
			break ;
		}
	} ,

	getDefaultHostName : function( ) {
		var hs = this._servicemap[ 'host' ] ;
		for ( var cnt = 0 ; hs.length ; cnt++ ) {
			if ( hs[ cnt ][ "isdefault" ] ) {
				return hs[ cnt ][ "name" ] ;
			}
		}
		return null ;
	} ,

	getDomainName : function( hostname ) {
		var ret = "" ;
		if ( hostname != null && hostname.length != 0 ) {
			ret = "http://" + hostname + ":" + this.getPort( hostname ) ;
		}
		return ret ;
	} ,

	getPath :function( hostname , servicename ) {
		var h = this._servicemap[ 'host' ] ;
		var p = null ;
		for ( var cnt = 0 ; cnt < h.length ; cnt++ ) {
			if ( h[ cnt ][ "name" ] == hostname ) {
				var s = h[ cnt ][ "service" ] ;
				for ( var kk = 0 ; kk < s.length ; kk++ ) {
					p = s[ kk ][ servicename ] ;
					if ( p ) {
						return p ;
					}
				}

			}
		}
		return p ;
	} ,

	getURL : function( hostname , servicename ) {
		return this.getDomainName( hostname ) + this.getPath( hostname , servicename ) ;
	} ,

	getPort : function( hostname ) {
		var hs = this._servicemap.host ;
		for ( var cnt = 0 ; hs.length ; cnt++ ) {
			if ( hs[ cnt ][ "name" ] == hostname ) {
				return hs[ cnt ][ "port" ] ;
			}
		}
		return null ;
	} ,

	postMultiRequest : function( multicmd ) {
		if ( this.isMultiCommunicate() ) {
			return false ;
		} else if ( this.isCommunicate() ) {
			return false ;
		} else {
			this._multicommands = multicmd ;
		}
		this._postNextMultiCommand() ;
	} ,

	_postNextMultiCommand : function() {

		if ( this._wait ) {
		//			clearInterval( this._postNextMultiCommand ) ;
			this._wait = false ;
		}

		if ( this._multicommands ) {
			var ncmd = this._multicommands.nextCommand() ;
			if ( ncmd ) {
				if ( this.postRequest( ncmd.command ) ) {
					ncmd.send = true ;
				} else {
					this._wait = true ;
					//setInterval( this._postNextMultiCommand , 1000 ) ;
			util.Timer.setTimer( this , 800 , "_postNextMultiCommand" ) ;
				}
			} else {
				var endcmd = this._multicommands ;
				this._multicommands = null ;
				endcmd.onCompleted() ;
				endcmd.dispose() ;
			}
		}
	} ,

	isMultiCommunicate : function() {
		return ( this._multicommands != null ) ? true : false ;
	} ,

	isCommunicate : function() {
		return (this._command != null ) ? true : false ;
	} ,

	postRequest : function( cmd ) {
		if ( this.isCommunicate() ) {
			return false ;
		} else if ( ! cmd || ! cmd.getServiceName() ) {
			return false ;
		} else {
			this._command = cmd ;
		}

		this.fireRequest() ;
		return true ;
	} ,

	forcePostRequest : function( cmd ) {
		var url = this.getURL( cmd.getHostName() , cmd.getServiceName() ) ;
		if ( cmd.getURL() ) {
			url = cmd.getURL() ;
		} else {
			url = this.getURL( cmd.getHostName() , cmd.getServiceName() ) ;
		}
		var req = this.createForceHttpRequest( cmd ) ;
		if ( req ) {
			req.open( cmd.getMethod() , url ,  true ) ;
			if ( cmd.getContentType() ) {
				req.setRequestHeader('Content-Type', cmd.getContentType() );
			}
			if ( cmd.getMethod() == "GET" ) {
				req.send( null ) ;
			} else {
				req.send( cmd.sendDirectData() ? cmd.getData() : this.createXMLMessage( cmd.getData() ) ) ;
			}
			return true ;
		}
		return false ;
	} ,

	createForceHttpRequest : function( cmd ) {
		var req = createXMLHttpRequest() ;
		if ( req ) {
			var res = new TransportResponder( req , cmd ) ;
			req.onreadystatechange = function( e ) { return res.onReadyState( e ) } ;
			return req ;
		}
		return null ;
	} ,

	fireRequest : function() {
		var url = null ;
		if ( this._command.getURL() ) {
			url = this._command.getURL() ;
		} else {
			url = this.getURL( this._command.getHostName() , this._command.getServiceName() ) ;
		}
//alert( "URL : " + url +  " Method : " + this._command.getMethod() + "\n\nData : " + this._command.getData() ) ;
		this.setupHttpRequest() ;
		if ( ! this._req ) {
			alert( "Can't Communication !!!" ) ;
			return false;
		}
//alert( "SEnd : " + this.createXMLMessage( this._command.getData() ) ) ;
		this._req.open( this._command.getMethod() , url ,  true ) ;
		if ( this._command.getContentType() ) {
			this._req.setRequestHeader('Content-Type', this._command.getContentType() );
		}
		if ( this._command.getMethod() == "GET" ) {
			this._req.send( null ) ;
		} else {
			this._req.send( this._command.sendDirectData() ? this._command.getData() : this.createXMLMessage( this._command.getData() ) ) ;
		}
	} ,

	createXMLMessage : function( data ) {
		var ret = "<XMLMessage lang=\"JP\" ><SendData>" ;
		ret += data ;
		ret += "</SendData></XMLMessage>" ;
		return ret;
	} ,

	setupHttpRequest : function( ) {
		this._req = createXMLHttpRequest() ;
		if ( this._req ) {
			var o = this ;
			this._req.onreadystatechange = function( e ) { return o.onReadyState( e ) } ;

		}
	} ,

	onLoading : function() {
		if ( this._command ) {
			this._command.onLoading() ;
		}
	} ,

	onLoaded : function() {
		if ( this._command ) {
			this._command.onLoaded() ;
		}
	} ,

	onInterActive : function() {
		if ( this._command ) {
			this._command.onInterActive() ;
		}
	} ,

	onCompleted : function() {

//alert( "Ready : " + this._req.readyState + " status : " + this._req.status ) ;

		var reqcommand = this._command ;
		this._command = null ;

		try {
			if ( ! this.isSuccessfull( this._req.status , this._req.readyState ) ) {
				this.defaultSystemError( this._req.status , { CODE : '---' , MESSAGE : util.LiteralBundle.getLiteral( 'label_syserr_communication' ) , DESCRIPTION : '' } ) ;
				return ;
			}
		} catch (e) {
//		alert(e) ;
			return ;
		}

		var response = new net.ResponseWrapper( this._req , reqcommand.getParseMode() ) ;
		var sts = response.getLoginState() ;
		var lchk = reqcommand.getLoginCheck() ;
		if ( sts == 0 && lchk == true ) {
		this._command = reqcommand ;
			this.defaultError() ;
			return ;
		} else if ( sts == -1 && lchk == true ) {
			this.defaultSystemError( this._req.status , response.getErrorMessage() ) ;
			return ;
		} else {
			if ( reqcommand ) {
//alert( "Set Response " + response + " cmd : " + this._command.getData() ) ;
				reqcommand.onCompleted( response ) ;
				reqcommand.dispose() ;
			}
		}

		reqcommand.onFinallyEvent() ;

		if ( this.isMultiCommunicate() ) {
			this._postNextMultiCommand() ;
		}

	} ,

	onFinallyEvent : function() {

	} ,

	defaultError : function() {
	var argobj = {} ;
	argobj[ "width" ] =  340 ;
	argobj[ "height" ] = 170 ;

	argobj[ "content" ] = util.LoginDialogHelper.createLoginHtml() ;

	if ( _page.dialogmanager.getCurrentDialog() ) {
		_page.dialogmanager.changeDialog( DialogManager.DIALOG_CONTENTHANDLE , argobj ) ;
	} else {
		_page.dialogmanager.openDialog( DialogManager.DIALOG_CONTENTHANDLE , argobj ) ;
	}

	/*
		_page.dialogmanager.openMessageDialogWidthEventHandler( MessageDialog.ICON_ERROR_STAUS ,'ERROR_SESSION_TIMEOUT' , MessageDialog.BUTTON_TYPE_OK ,
			function( sts ) {
				_page.pagemanager.movePage( "" ) ;
			 } , null ) ;
	*/
	} ,

	defaultSystemError : function( sts , arg ) {
		arg['STATUS'] = sts ;
		util.openSystemError( arg ) ;
	} ,

	isSuccessfull : function( sts , ready ) {

		switch ( sts ) {
			case 200: // OK
			case 304: // Not Modified
			return true;
			case 206: // Partial Content
			return ready !== 4;

			case 204: // No Content
			case 300: // Multiple Choices
			case 301: // Moved Permanently
			case 302: // Moved Temporarily
			case 303: // See Other
			case 305: // Use Proxy
			case 400: // Bad Request
			case 401: // Unauthorized
			case 402: // Payment Required
			case 403: // Forbidden
			case 404: // Not Found
			case 405: // Method Not Allowed
			case 406: // Not Acceptable
			case 407: // Proxy Authentication Required
			case 408: // Request Time-Out
			case 409: // Conflict
			case 410: // Gone
			case 411: // Length Required
			case 412: // Precondition Failed
			case 413: // Request Entity Too Large
			case 414: // Request-URL Too Large
			case 415: // Unsupported Media Type
			case 500: // Server Error
			case 501: // Not Implemented
			case 502: // Bad Gateway
			case 503: // Out of Resources
			case 504: // Gateway Time-Out
			case 505: // HTTP Version not supported
			return false;

			default:
			return false ;
		}
	}


}

net.Transporter = new BaseTransporter() ;

/*
 ************************************************************************
 *  TransportResponder
 ************************************************************************
 */


TransportResponder = function( req , cmd ) {
    this._command = cmd ;
    this._req = req ;
}


TransportResponder.prototype = {

    setupParams : function( req , cmd ) {
        this._req = req ;
        this._command = cmd ;
    } ,

    onReadyState : function( e ) {
        var ready = this._req.readyState ;
        switch ( ready ) {
            case 1 :
                this.onLoading() ;
            break ;
            case 2 :
                this.onLoaded() ;
            break ;
            case 3 :
                this.onInterActive() ;
            break ;
            case 4 :
                this.onCompleted() ;
            break ;
        }
    } ,

    onLoading : function() {
        if ( this._command ) {
            this._command.onLoading() ;
        }
    } ,

    onLoaded : function() {
        if ( this._command ) {
            this._command.onLoaded() ;
        }
    } ,

    onInterActive : function() {
        if ( this._command ) {
            this._command.onInterActive() ;
        }
    } ,

    onCompleted : function() {
        var reqcommand = this._command ;
        this._command = null ;

        if ( ! this.isSuccessfull( this._req.status , this._req.readyState ) ) {
            this.defaultSystemError( this._req.status , { CODE : '---' , MESSAGE : util.LiteralBundle.getLiteral( 'label_syserr_communication' ) , DESCRIPTION : '' } ) ;
            return ;
        }

        var response = new net.ResponseWrapper( this._req , reqcommand.getParseMode() ) ;
        var sts = response.getLoginState() ;
        var lchk = reqcommand.getLoginCheck() ;
        if ( sts == 0 && lchk == true ) {
            this.defaultError() ;
            return ;
        } else if ( sts == -1 && lchk == true ) {
            this.defaultSystemError( this._req.status , response.getErrorMessage() ) ;
            return ;
        } else {
            if ( reqcommand ) {
                reqcommand.onCompleted( response ) ;
                reqcommand.dispose() ;
            }
        }

        reqcommand.onFinallyEvent() ;

    } ,

    onFinallyEvent : function() {
        
    } ,

    defaultError : function() {
        _page.dialogmanager.openMessageDialogWidthEventHandler( MessageDialog.ICON_ERROR_STAUS ,'ERROR_SESSION_TIMEOUT' , MessageDialog.BUTTON_TYPE_OK ,
            function( sts ) { 
                _page.ContentsManager.movePage( "" ) ;
             } , null ) ;
    } ,

    defaultSystemError : function( sts , arg ) {
        arg['STATUS'] = sts ;
        util.openSystemError( arg ) ;
    } ,

    isSuccessfull : function( sts , ready ) {

        switch ( sts ) {
            case 200: // OK
            case 304: // Not Modified
            return true;
            case 206: // Partial Content
            return ready !== 4;

            case 204: // No Content
            case 300: // Multiple Choices
            case 301: // Moved Permanently
            case 302: // Moved Temporarily
            case 303: // See Other
            case 305: // Use Proxy
            case 400: // Bad Request
            case 401: // Unauthorized
            case 402: // Payment Required
            case 403: // Forbidden
            case 404: // Not Found
            case 405: // Method Not Allowed
            case 406: // Not Acceptable
            case 407: // Proxy Authentication Required
            case 408: // Request Time-Out
            case 409: // Conflict
            case 410: // Gone
            case 411: // Length Required
            case 412: // Precondition Failed
            case 413: // Request Entity Too Large
            case 414: // Request-URL Too Large
            case 415: // Unsupported Media Type
            case 500: // Server Error
            case 501: // Not Implemented
            case 502: // Bad Gateway
            case 503: // Out of Resources
            case 504: // Gateway Time-Out
            case 505: // HTTP Version not supported
            return false;

            default:
            return false ;
        }
    }


}

/* ************************************************************************
 * Classes
 *  - WebServiceHandler
 *
 ************************************************************************ */

/* ************************************************************************
 * Response Reader
 ************************************************************************ */
function JSONParser ( aignorezerotext ) {
    this._ignore_zero_length_text = (aignorezerotext) ? aignorezerotext : true ;
}

JSONParser.prototype.parseResponseXML = function( root ) {

    if ( root == null ) {
        return null ;
    }

    var json = {} ;
    json[ root.nodeName ] = this.parseElement( root ) ;
    return json ;
}


JSONParser.prototype.parseElement = function( elm ) {

    if ( elm.nodeType == net.Parser.PROCESSING_INSTRUCTION_NODE ) {
        return null ;
    }

    // Text Node , CDATA SECTION NODE
    if ( elm.nodeType == net.Parser.TEXT_NODE ) {
        return this.createText( net.Parser.TEXT_NODE_NAME , elm.nodeValue ) ;
    }

    if ( elm.nodeType == net.Parser.CDATA_SECTION_NODE ) {
        return this.createText( net.Parser.CDATA_NODE_NAME , elm.nodeValue ) ;
    }

    // Element

    var targ = {} ;
    var attrs = null ;
    var childcnt = {} ;
    var tmp = null ;

    if ( elm.childNodes && elm.childNodes.length ) {

        for ( var jj = 0 ; jj < elm.childNodes.length ; jj++ ) {

            var key = elm.childNodes[ jj ].nodeName ;
            if ( typeof( key ) != "string" ) continue ;

            tmp = this.parseElement( elm.childNodes[ jj ] ) ;

            if ( tmp == null ) {
                continue ;
            }

            var childval = targ[ key ] ;

            if ( childval ) {
                if ( childcnt[ key ] == 1 ) {
                    childval = [ targ[ key ] , tmp ] ;
                    childcnt[ key ]++ ;
                    targ[ key ] = childval ;
                } else {
                    childval.push( tmp ) ;
                }
            } else {
                targ[ key ] = tmp ;
                childcnt[ key ] = 1 ;
            }

        }

    }

    // Attribute
    if ( elm.attributes && elm.attributes.length ) {
        for ( var kk = 0 ; kk < elm.attributes.length ; kk++ ) {
            var k = elm.attributes[ kk ].nodeName ;
            if ( typeof( k ) != "string" ) continue ;
            var val = elm.attributes[ kk ].nodeValue ;
            if ( ! val ) continue ;
            targ[ k ] = val ;
        }
    }

    return targ ;
}

JSONParser.prototype.createText = function( ndnm , data ) {
    if ( data == null ) {
        return { TEXT :  "" } ;
    }
    if ( this._ignore_zero_length_text ) {
        if ( data.length == 0 ) {
            return null ;
        }
    }
    return { TEXT : data } ;
}

net.Parser.JSON = new JSONParser() ;


/* ************************************************************************
 *  LogParser
 *
 ************************************************************************ */

/* ************************************************************************
 * Response Reader
 ************************************************************************ */
function LogParser ( ) {

}

LogParser.prototype.parseResponseXML = function( root ) {
    if ( root == null ) {
        return null ;
    }

    if ( ! this.isLogined( root ) ) {
        return null ;
    }
    var LogItm = this.searchLogItem( root ) ;
    if ( LogItm ) {
        var ret = {} ;
        ret[ 'INFO' ] = this.getInfo( root ) ;
        var logs = [] ;
        for ( var cnt = 0 ; cnt < LogItm.childNodes.length ; cnt++ ) {
            logs.push( { level : { text : LogItm.childNodes[ cnt ].attributes.getNamedItem("level").nodeValue } ,
                        date : { text : LogItm.childNodes[ cnt ].attributes.getNamedItem("date").nodeValue } ,
                        num : { text : LogItm.childNodes[ cnt ].attributes.getNamedItem("num").nodeValue } ,
                        threadname : { text : LogItm.childNodes[ cnt ].attributes.getNamedItem("threadname").nodeValue } ,
                        category : { text : LogItm.childNodes[ cnt ].attributes.getNamedItem("category").nodeValue } ,
                        message : { text : this.getText( LogItm.childNodes[ cnt ] ) } } ) ;

        }
        ret['LOG'] =logs ;
        return ret ;
    }
    return null ;
}

LogParser.prototype.getInfo = function( root ) {
    var targ = root ;
    var elms = [ 'SendData' , 'Log' , 'Info' ] ;
    for ( var cnt = 0 ; cnt < elms.length ; cnt++ ) {
        tmp = this.findElement( targ , elms[ cnt ] ) ;
        if ( tmp ) {
            targ = tmp ;
        } else {
            return null ;
        }
    }
    return net.Parser.JSON.parseResponseXML( targ ) ;
}

LogParser.prototype.searchLogItem = function( root ) {
    var targ = root ;
    var elms = [ 'SendData' , 'Log' , 'LogItem' ] ;
    var tmp = null ;
    for ( var cnt = 0 ; cnt < elms.length ; cnt++ ) {
        tmp = this.findElement( targ , elms[ cnt ] ) ;
        if ( tmp ) {
            targ = tmp ;
        } else {
            return null ;
        }
    }
    return targ ;
}

LogParser.prototype.findElement = function( elm , name ) {
    var targ = elm ;
    if ( targ.childNodes && targ.childNodes.length ) {
        for ( var cnt = 0 ; cnt < targ.childNodes.length ; cnt++ ) {
            if ( targ.childNodes[ cnt ].nodeName == name ) {
                return targ.childNodes[ cnt ] ;
            }
        }
    }
    return null ;
}

LogParser.prototype.getText = function( elm ) {
    if ( elm.childNodes && elm.childNodes.length ) {
        return elm.childNodes[ 0 ].nodeValue ;
    }
}

LogParser.prototype.isLogined = function( elm ) {
    var result = this.findElement( elm , "Result" ) ;
    if ( result ) {
        if ( result.attributes.getNamedItem("code").nodeValue == "success" ) {
            return true ;
        }
        return false ;
    }
    return false
}

net.Parser.LOG = new LogParser() ;

/*
 ************************************************************************
 *  LoopTransportResponder
 ************************************************************************
 */


LoopTransportResponder = function( req , cmd , mgr ) {
    TransportResponder.call(this ,  req , cmd ) ;
    this._command = cmd ;
    this._req = req ;
    this._manager = mgr ;
}

LoopTransportResponder.extend( TransportResponder , "LoopTransportResponder" ) ;

LoopTransportResponder.prototype.onCompleted = function() {
    var reqcommand = this._command ;
    this._command = null ;

    if ( ! this.isSuccessfull( this._req.status , this._req.readyState ) ) {
        this.defaultSystemError( this._req.status , { CODE : '---' , MESSAGE : util.LiteralBundle.getLiteral( 'label_syserr_communication' ) , DESCRIPTION : '' } ) ;
        return ;
    }

    var response = new net.ResponseWrapper( this._req , reqcommand.getParseMode() ) ;
    var sts = response.getLoginState() ;
    var lchk = reqcommand.getLoginCheck() ;
    if ( sts == 0 && lchk == true ) {
        this.defaultError() ;
        return ;
    } else if ( sts == -1 && lchk == true ) {
        this.defaultSystemError( this._req.status , res.getErrorMessage() ) ;
        return ;
    } else {
        if ( reqcommand ) {
            reqcommand.onCompleted( response ) ;
            reqcommand.dispose() ;
        }
    }

    reqcommand.onFinallyEvent() ;

    if ( this._manager ) {
        this._manager.doPostRequest() ;
    }
}

/*
 ************************************************************************
 *  LoopTransporter
 ************************************************************************
 */


LoopTransporter = function( intervalTime ) {
    BaseTransporter.call(this) ;
    this._loopcommand = null ;
    this._loop = false ;
    this._intervaltime = (intervalTime ==null)?LoopTransporter.DEFAULT_INTERVAL:intervalTime ;
    this._timeoutid = null ;
}

LoopTransporter.extend( BaseTransporter , "LoopTransporter" ) ;

LoopTransporter.DEFAULT_INTERVAL = 3000 ;

LoopTransporter.prototype.createCommand = function() {
}

LoopTransporter.prototype.setCommand = function( ) {
    this._loopcommand = this.createCommand() ;
}

LoopTransporter.prototype.start = function() {
    this._loop = true ;
    this.loopPostRequest() ;
}

LoopTransporter.prototype.loopPostRequest = function() {

    this.setCommand() ;
    this.postRequest( this._loopcommand ) ;

}

LoopTransporter.prototype.stop = function() {
    this._loop = false ;
}

LoopTransporter.prototype.onCompleted = function() {

//alert( "Ready : " + this._req.readyState + " status : " + this._req.status ) ;
//alert( "Ready : " + this._req.readyState + " Leave : " + _page.pageloader.getMode() ) ;

    if ( ! this._loop ) {
        return ;
    }

    var reqcommand = this._command ;
    this._command = null ;

    try {
        if ( ! this.isSuccessfull( this._req.status , this._req.readyState ) ) {
            this.defaultSystemError( this._req.status , { CODE : '---' , MESSAGE : util.LiteralBundle.getLiteral( 'label_syserr_communication' ) , DESCRIPTION : '' } ) ;
            return ;
        }
    } catch (e) {
//        alert(e) ;
        return ;
    }


    var response = new net.ResponseWrapper( this._req , reqcommand.getParseMode() ) ;
    var sts = response.getLoginState() ;
    var lchk = reqcommand.getLoginCheck() ;
    if ( sts == 0 && lchk == true ) {
        this.defaultError() ;
        return ;
    } else if ( sts == -1 && lchk == true ) {
        if ( response.isExistElement() ) {
            this.defaultSystemError( this._req.status , response.getErrorMessage() ) ;
        } else {
            this.defaultSystemError( this._req.status , { CODE : '---' , MESSAGE : util.LiteralBundle.getLiteral( 'label_syserr_communication' ) , DESCRIPTION : response.getText() } ) ;
        }
        return ;
    } else {
        if ( reqcommand ) {
            reqcommand.onCompleted( response ) ;
            reqcommand.dispose() ;
        }
    }

    reqcommand.onFinallyEvent() ;

    if ( this._loop ) {
        util.Timer.setTimer( this , this._intervaltime , "loopPostRequest" ) ;
    }

}


/* ************************************************************************
 * Classes
 *  - CommonCommand
 *
 ************************************************************************ */


net.MultiTransportCommand = function( ) {
    this._commands = null ;
}

net.MultiTransportCommand.extend( Object , "MultiTransportCommand" ) ;

net.MultiTransportCommand.prototype = {

    addCommand : function( cmd ) {
        if ( ! this._commands ) {
            this._commands = new Array() ;
        }
        this._commands.push( { command : cmd , send : false } ) ;
    } ,

    size : function() {
        return (this._commands) ? this._commands.length : 0 ;
    } ,

    getCommand : function( idx ) {
        return this._commands[ idx ] ;
    } ,

    nextCommand : function() {
        var len = this.size() ;
        for ( var kk = 0 ; kk < len ; kk++ ) {
            if ( ! this._commands[ kk ].send ) {
                return this._commands[ kk ] ;
            }
        }
        return null ;
    } ,

    onCompleted : function() {
    
    } ,

    dispose : function() {
        this._commands = null ;
    }

}

/* ************************************************************************
 * Classes
 *  - ResponseWrapper
 *
 ************************************************************************ */


/* ************************************************************************
 * ResponseWrapper
 ************************************************************************ */


net.ResponseWrapper = function( res , parse ) {
	this._loginCheck = res.getResponseHeader( "PL_CLIENT_LOGIN" ) ;
    this._parse = (parse) ? parse : net.Parser.PARSER_TYPE_NONE ;
    if ( res ) {
        this._text = res.responseText ;
        this._xmldoc = res.responseXML ;
        this._messagedata = this._buildData( ) ;
    } else {
        this._text       = null ;
        this._xmldoc     = null ;
        this._messagedata = null ;
    }
}

net.ResponseWrapper.prototype.getLoginState = function() {
    if ( this._loginCheck ) {
        if ( this._loginCheck == "true" ) {
            return 1 ;
        } else if (  this._loginCheck == "none"  ) {
			return 1 ;
		}
        return 0 ;
    }
    return -1 ;
}

net.ResponseWrapper.prototype.getLang = function() {
    if ( this._response ) {
        return null ;
    }
    return this.getRootElement( ).getNodeAttribute( "lang" ) ;
}

net.ResponseWrapper.prototype.getSendDataElement = function() {
    var root = this.getRootElement() ;
    if ( root ) {
        return root[ "SendData" ] ;
    }
    return null ;
}

net.ResponseWrapper.prototype.getResultElement = function() {
    var root = this.getRootElement() ;
    if ( root ) {
        return root[ "Result" ] ;
    }
    return null ;
}

net.ResponseWrapper.prototype.getRootElement = function() {
    return this._messagedata==null?null:this._messagedata[ 'XMLMessage' ] ;
}

net.ResponseWrapper.prototype.getRootXMLElement = function() {
    var c = this._xmldoc.childNodes[ 0 ] ;
    if ( c ) {
        if ( c.nodeName == "xml" ) {
            return this._xmldoc.childNodes[ 1 ] ;
        }
        return c ;
    }
    return null ;
}

net.ResponseWrapper.prototype.isExistElement = function( targ ) {
    if ( this._messagedata == null ) {
        return false ;
    }
    var root = this.getRootElement() 
    if ( root ) {
        return (root[ targ ] == null) ? false : true ;
    }
    return false ;
}

net.ResponseWrapper.prototype._buildData = function( ) {

    if ( this._parse == net.Parser.PARSER_TYPE_NONE ) {
        return null ;
    }

    var root = this.getRootXMLElement() ;
    if ( root ) {
        if ( this._parse == net.Parser.PARSER_TYPE_JSON ) {
            return net.Parser.JSON.parseResponseXML( root ) ;
        } else if ( this._parse == net.Parser.PARSER_TYPE_LOG ) {
            return net.Parser.LOG.parseResponseXML( root ) ;
        }
    }

    return null ;
}

net.ResponseWrapper.prototype.getText = function( ) {
    return this._text ;
}

net.ResponseWrapper.prototype.getXMLElement = function( ) {
    return this._xmldoc ;
}

net.ResponseWrapper.prototype.getParsedData = function( ) {
    return this._messagedata ;
}


net.ResponseWrapper.prototype.getErrorMessage = function( ) {

    var txt = this.getText() ;
    if ( txt.substring( 0 , 6 ) == "<html>" ) {
        return txt ;
    }

    var result = this.getResultElement() ;
    var ret = {} ;
    if ( result ) {
        if ( result['ErrorMessages'] ) {
            var err = result['ErrorMessages']['Error'] ;
            ret['CODE'] = err['code'] ;
            ret['MESSAGE'] = err['Message'][ '#text' ]['TEXT'] ;
            ret['DESCRIPTION'] = err[ 'Description' ][ '#text' ]['TEXT'] ;
        }
    }
    if ( ret['CODE'] ) {
        ret['CODE'] = "" ;
        ret['MESSAGE'] = "" ;
        ret['DESCRIPTION'] = "" ;
    }
    return ret ;
}


/* ************************************************************************
 * Classes
 *  - CommonCommand
 *
 ************************************************************************ */


net.TransportCommonCommand = function( servicename , data , hostname ) {

    this._servicename = servicename ;
    this._data = (data) ? data : "" ;
    this._hostname = net.DEFAULT_HOST_NAME ;
    if ( hostname ) {
        this._hostname = hostname ;
    }
    this._method = "POST" ;
    this._attrs = {} ;
    this._logincheck = true ;
    this._parser_mode = net.Parser.PARSER_TYPE_JSON ;
    this._url = null ;
    this._contenttype = net.DEFAULT_CONTENT_TYPE ;

}

net.TransportCommonCommand.extend( Object , "TransportCommonCommand" ) ;

net.TransportCommonCommand.prototype = {

    onLoading : function() {
        return ;
    } ,

    onLoaded : function() {
        return ;
    } ,

    onInterActive : function() {
        return ;
    } ,

    onCompleted : function( res ) {
        return ;
    } ,

    onError : function() {
        return ;
    } ,

    onSystemError : function() {
        return ;
    } ,

    onFinallyEvent : function() {
        return ;
    } ,

    getServiceName : function() {
        return this._servicename ;
    } ,

    getData : function() {
        return this._data ;
    } ,

	sendDirectData : function() {
		return false ;
	} ,

    getHostName : function() {
        return this._hostname ;
    } ,

    getMethod : function() {
        return this._method
    } ,

    setMethod : function( mtd ) {
        this._method = mtd ;
    } ,

    putRequstHeader : function( k , v ) {
        this._attrs[ k ] = v ;
    } ,

    getRequestHeader : function( k ) {
        for ( var key in this._attrs ) {
            if ( k == key ) {
                return this._attrs[ key ] ;
            }
        }
        return null ;
    } ,

    getRequestHeaderKeys : function() {
        var ret = [] ;
        for ( var k in this._attrs ) {
            ret.push( k ) ;
        }
        return ret ;
    } ,

    setData : function( dat ) {
        this._data = dat ;
    } ,

    getData : function( ) {
        return this._data ;
    } ,

    setLoginCheck : function( flg ) {
        this._logincheck = flg ;
    } ,

    getLoginCheck : function( ) {
        return this._logincheck ;
    } ,

    setParseMode : function( md ) {
        this._parser_mode = md ;
    } ,

    getParseMode : function() {
        return this._parser_mode ;
    } ,

    setContentType : function( ct ) {
        this._contenttype = ct ;
    } ,

    getContentType : function() {
        return this._contenttype ;
    } ,

    setURL : function( u ) {
        this._url = u ;
    } ,

    getURL : function() {
        return this._url ;
    } ,

    dispose : function() {
        this._servicename = null ;
        this._data        = null ;
        this._hostname    = null ;
        this._method      = null ;
        for ( var vk in this._attrs ) {
            this._attrs[ vk ] = null ;
        }
        this._attrs       = null ;
        this._url = null ;
        this._contenttype = null ;
    }

}

/*
 * FileSystemCommand
 */

net.FileSystemCommand = function( elid , data , evt , mtd) {
    net.TransportCommonCommand.call( this, "dummy", data, null ) ;
	this.setMethod( mtd == null? "GET":mtd ) ;
	this.setURL( this.getMethod() == "GET"?"/mc/filebrowse.mc?" + data: "/mc/filebrowse.mc" ) ;
	if ( this.getMethod() == "POST" ) {
		this.setData( data ) ;
	}
	this.setLoginCheck( false ) ;
	this.setParseMode( net.Parser.PARSER_TYPE_NONE ) ;
	this.elID = elid ;
	this._eventHandler = evt ;
}

net.FileSystemCommand.extend( net.TransportCommonCommand , "FileSystemCommand" ) ;

net.FileSystemCommand.prototype.sendDirectData = function( ) {
	return true ;
}

net.FileSystemCommand.prototype.onCompleted = function( res ) {
	var el = document.getElementById( this.elID ) ;
	el.innerHTML = res.getText() ;
	if ( this._eventHandler ) {
		this._eventHandler( res ) ;
	}
}/* ************************************************************************
 * Classes
 *  - LoginCommand
 *
 ************************************************************************ */

net.RequestCommand = function( servicename , data , hostname ) {
    net.TransportCommonCommand.call( this, servicename, data, hostname ) ;
}

net.RequestCommand.extend( net.TransportCommonCommand , "RequestCommand" ) ;

/*
 * SimpleCommand
 */


net.SimpleCommand = function( url , data , mtd) {
    net.TransportCommonCommand.call( this, "dummy", data, null ) ;
	this.setMethod( mtd == null? "GET":mtd ) ;
	this.setURL( this.getMethod() == "GET"? url + "?" + data : url ) ;
	if ( this.getMethod() == "POST" ) {
		this.setData( data ) ;
	}
	this.setParseMode( net.Parser.PARSER_TYPE_NONE ) ;
}
net.SimpleCommand.extend( net.TransportCommonCommand , "SimpleCommand" ) ;
net.SimpleCommand.prototype.sendDirectData = function( ) { return true ;}
